<?php
namespace Fiscal\Logic\NotaFiscalEletronica;
use \Fiscal\Util\Parametros;
use \Geral\Util\Dataset;
use \Fiscal\Entities\Notafiscal;
use \Geral\Util\Util;
use \Fiscal\Logic\StoredProcedures;
use \Geral\Entities\Formpgto;
use \Geral\Util\DatasetRepository;
use \Fiscal\Entities\Dadosadic;
use \Geral\Entities\Itemproduto;
use \Indeterminado\Entities\Decimpnfe;
use \Indeterminado\Entities\Adicdecimpnfe;
use \Fiscal\Entities\Vrmaxvenprod;
use \Geral\Entities\Encargo;
use \Fiscal\Entities\Itemproimpos;
use \Financeiro\Entities\Contareceber;
use \Geral\Entities\Produto;
use \Fiscal\Logic\NotaFiscalEletronica\ToolsNFePHP;
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 26/12/12
 * Time: 10:30aut
 * To change this template use File | Settings | File Templates.
 */
class V300
{
    /**@var $this->DOM \DOMDocument*/
    private $DOM;

    public function getXml()
    {
        return $this->xml;
    }
    private $xml;
    private $signedXML;
    private $fileName;
    private $tags = array();
    private $txtStructure = array();
    private $toolsNFE;
    private $repository;
    private $modoTransmissao;
    private $tipoEmissao;
    private $serie;
    private $chaveAcesso;
    private $numeroNotaFiscal;
    private $info;
    private $fileSize;
    private $valorTotalBC           = 0.00;
    private $valorTotalICMS         = 0.00;
    private $valorTotalICMSDeson    = 0.00;
    private $valorTotalBCST         = 0.00;
    private $valorTotalICMSST       = 0.00;
    private $valorTotalIPI          = 0.00;
    private $valorTotalVSERV        = 0.00;
    private $valorTotalVBCISSQN     = 0.00;
    private $valorTotalVISS         = 0.00;
    private $valorTotalPISISSQN     = 0.00;
    private $valorTotalCOFINS       = 0.00;
    private $valorTotalCOFINSISSQN  = 0.00;
    private $valorTotalVII          = 0.00;
    private $valorTotalPIS          = 0.00;
    private $valorTotalVPROD        = 0.00;
    protected $timeZone = '-03:00';
    public function getChaveAcesso(){
        return $this->chaveAcesso;
    }

    public function getfilename(){
        return $this->fileName;
    }

    public function __construct($corpoNotaFiscal, $tipoAmbiente, $modo, $siglaModulo, $nrlote)
    {
        try {
            $this->repository = DatasetRepository::getInstance();
            $this->corpoNF = $corpoNotaFiscal;
            $this->toolsNFE = new ToolsNFePHP(\Geral\Entities\Empresa::getRepository()->findOneBy(array("cdempresa" => $this->corpoNF["CDEMPRESA"], "nrorg" => $this->corpoNF["NRORG"])), $this->corpoNF["NRINSCESTEMIT"]);
            $this->modoTransmissao = $modo;
            $this->serie = $modo === Notafiscal::MODO_SERIE_SCAN ? $this->corpoNF["CDSERIESCAN"] : $this->corpoNF["CDSERIE"];

            $this->tipoAmbiente = $tipoAmbiente;
            $this->modulo = $siglaModulo;
            $this->numeroNotaFiscal = $this->geraNumeroNotaFiscal();
            $this->fileName = $nrlote . '-' . $this->corpoNF["NRLANCTONF"] . '-nfe.xml';
            $this->criaEstruturaXML();
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getSignedXML()
    {
        return $this->signedXML;
    }

    public function getNumeroNotaFiscal()
    {
        return $this->numeroNotaFiscal;
    }

    /**
     * @return null|float in KBytes
     */
    public function getFileSize()
    {
        return $this->fileSize;
    }

    /**
     * Gera arquivo de entrada da nota.
     * @throws \Exception
     */
    public function geraArquivoXML()
    {
        if ($this->xml){
            $filePath = $this->toolsNFE->entDir . $this->fileName;
            if (!file_put_contents($filePath,$this->xml)){
                throw new \Exception("ERRO na gravação do arquivo XML.");
            }
        }
    }

    /**
     * Assina XML e grava arquivo assinado
     * Assina XML e grava arquivo assinado
     */
    public function assinaXML()
    {
        if ($this->xml) {
            if ($this->signedXML = $this->toolsNFE->signXML($this->xml, "infNFe")) {
                $filePath = $this->toolsNFE->assDir . $this->fileName;
                file_put_contents($filePath, $this->signedXML);
                $this->fileSize = filesize($filePath) / 1024;
            }
        }
    }

    private function replaceCharsForParser($string)
    {
        $from = array(
            "<",
            ">",
            "&",
            "\"",
            "''"
        );

        $to = array(
            "&lt;",
            "&gt;",
            "&amp;",
            "&quot;",
            "&#39;"
        );

        return str_replace($from, $to, $string);
    }
    private function getFormaPagamento($identrsaidop, $cdfilial, $nrlanctonf, $idorigdestnf, $dtentrsaid)
    {
        if($idorigdestnf === "L"){
            return 0;
        }else{
            if($identrsaidop === "S"){
                $resultSetFormpgto = Formpgto::getRepository()->consultaFormaPagamentoSaida($cdfilial, $nrlanctonf, $idorigdestnf, $dtentrsaid);
                if(empty($resultSetFormpgto)){
                    return 2;
                }else{
                    return $resultSetFormpgto[0]["IDFORMPGTSAP"];
                }
            }else{
                $resultSetFormpgto = Formpgto::getRepository()->consultaFormaPagamentoEntrada($cdfilial, $nrlanctonf, $idorigdestnf, $dtentrsaid);
                if(empty($resultSetFormpgto)){
                    return 2;
                }else{
                    return $resultSetFormpgto[0]["IDFORMPGTSAP"];
                }
            }
        }
    }

    private function somaValorEncargo($codigo)
    {
        $valorEncargo = 0.00;
        $dstEncargo = DatasetRepository::getInstance()->get("nfeTransEncargo");

        $encargo = $dstEncargo->find(array("CDENCARGO" => $codigo));
        if ($encargo) {
            $itEncargo = $encargo->getIterator();
            while ($itEncargo->valid()) {
                $rowEncargo = $itEncargo->current();
                $valorEncargo += Util::decimalToFloat($rowEncargo["VALORENCARGOFLOAT"]);
                $itEncargo->next();
            }
        }

        return (float)number_format($valorEncargo, 2, ".", "");
    }

    public function getFileVersion()
    {
        $regexp = "/VERSAO(\s+\d+\.\d+\.\d+)/";
        if(preg_match($regexp, Util::readFileLastLine(__FILE__), $matches)){
            return trim($matches[1]);
        }

        return null;
    }


    private function criaEstruturaXML()
    {
        try {
            $this->initializeDOM();
            $this->txtStructure[] = "NOTAFISCAL|1";
            $this->criaTagAtributos();
            $this->criaTagIdentificacao();
            $this->criaTagEmitente();
            $this->criaTagDestinatario();
            $this->criaTagItensNotafiscal();
            if (isset($this->tags["infNFe"])) {
                $this->tags["NFe"]->appendChild($this->tags["infNFe"]);
                $this->DOM->appendChild($this->tags["NFe"]);
                $this->__montaChaveXML();
                $xml = $this->DOM->saveXML();
                $xml = str_replace('<?xml version="1.0" encoding="UTF-8  standalone="no"?>', '<?xml version="1.0" encoding="UTF-8"?>', $xml);
                //remove linefeed, carriage return, tabs e multiplos espaços
                $xml = preg_replace('/\s\s+/', ' ', $xml);
                $xml = str_replace("> <", "><", $xml);
                $this->xml = $xml;
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function initializeDOM()
    {
        $this->DOM = new \DOMDocument('1.0', 'UTF-8');
        $this->DOM->formatOutput = true;
        $this->DOM->preserveWhiteSpace = false;
        $this->tags["NFe"] = $this->DOM->createElement("NFe");
        $this->tags["NFe"]->setAttribute("xmlns", "http://www.portalfiscal.inf.br/nfe");
    }

    private function criaTagAtributos()
    {
        unset($id, $versao);

        if($this->corpoNF["IDTIPOEMISNFE"] === "0"){
            $this->tipoEmissao = $this->modoTransmissao;
        }else{
            if(($this->corpoNF["IDTIPOEMISNFE"] === "1" && $this->modoTransmissao === Notafiscal::MODO_SERIE_SCAN) || ($this->corpoNF["IDTIPOEMISNFE"] === "3" && $this->modoTransmissao === Notafiscal::MODO_SERIE_NORMAL)){
                $this->tipoEmissao = $this->modoTransmissao === Notafiscal::MODO_SERIE_SCAN ? 3 : 1;
            }else{
                $this->tipoEmissao = $this->corpoNF["IDTIPOEMISNFE"];
            }
        }

        if ($this->corpoNF["CDPAISBACENEMIT"] === '1058') {
            $cnpjEmitente = Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"]);
        } else {
            //Caso o emitente nao seja do brasil (caso de notas de importação)
            $cnpjEmitente = Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"]);
            $cnpjEmitente = str_pad(trim(substr($cnpjEmitente, strlen($cnpjEmitente)-14, 14)), 14, "0");
        }
        $dtEmissao = $this->corpoNF["DTEMISSAO"];
        $arTipoEmis = array("2","3","4","5");
        if(in_array($this->tipoEmissao, $arTipoEmis)){
            $atual = \DateTime::createFromFormat('d/m/Y H:i:s', now(), new \DateTimeZone('America/Sao_Paulo'));
            if($this->tipoEmissao === "4"){
                if($atual->format("d") === "1"){
                    $objDtEmiss = \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTEMISSAO"], new \DateTimeZone('America/Sao_Paulo'));
                    if($atual->format("m") === $objDtEmiss->format("m")){
                        $dtEmissao = $objDtEmiss->modify("-1 month")->format('d/m/Y');
                    }
                }
            }
        }

        $aamm = \DateTime::createFromFormat('d/m/Y H:i:s', $dtEmissao, new \DateTimeZone('America/Sao_Paulo'))->format("Ym");
        $this->chaveAcesso = \Fiscal\Util\Util::geraChaveAcessoNFE($this->corpoNF["NRLANCTONF"], $this->tipoEmissao, $this->corpoNF["CDESTAIBGEEMIT"], $aamm, $cnpjEmitente, "55", $this->serie);

        $id = "NFE".$this->chaveAcesso;
        $versao = Notafiscal::NFE_VERSAO_310;

        $this->tags["infNFe"] = $this->DOM->createElement("infNFe");
        $this->tags["infNFe"]->setAttribute("Id", $id);
        $this->tags["infNFe"]->setAttribute("versao", Notafiscal::NFE_VERSAO_310);

        $this->txtStructure[] = "A|$id|$versao";
    }




    private function criaTagIdentificacao()
    {
        $dtEmi = \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTEMISSAO"], new \DateTimeZone('America/Sao_Paulo'));
        if($this->corpoNF["IDENTRSAIDOP"] !== Notafiscal::NOTA_FISCAL_ENTRADA){
            if(Parametros::getUtilizaDataProcNFE() === "S"){
                $objTipoOperac = \Geral\Entities\Tipooperac::getObjectByWhere("CDTIPOOPER = ? AND IDENTRSAIDOP = ?", array($this->corpoNF["CDTIPOOPER"], $this->corpoNF["IDENTRSAIDOP"]));
                $idtptransnfe = $objTipoOperac->getIdtptransnfe();
                if($idtptransnfe === "N" || $idtptransnfe === "C" || $idtptransnfe === null){
                    $dtSaiEnt = \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTENTRSAID"], new \DateTimeZone('America/Sao_Paulo'));
                }else{
                    $dtEmi = \DateTime::createFromFormat('d/m/Y', Parametros::getDataProcessamento(), new \DateTimeZone('America/Sao_Paulo'));
                    $dtEntrSaid = new \Zend_Date($this->corpoNF["DTENTRSAID"], null, 'pt_BR');
                    $dtProc = new \Zend_Date(Parametros::getDataProcessamento(), null, 'pt_BR');
                    // Data fim nao pode ser menor que data inicio
                    if($dtProc->compare($dtEntrSaid) < 0){
                        $dtSaiEnt = \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTENTRSAID"], new \DateTimeZone('America/Sao_Paulo'));
                    }else{
                        $dtSaiEnt = \DateTime::createFromFormat('d/m/Y', Parametros::getDataProcessamento(), new \DateTimeZone('America/Sao_Paulo'));
                    }
                }
            }else{
                $dtSaiEnt = \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTENTRSAID"], new \DateTimeZone('America/Sao_Paulo'));
            }
        }

        $cUF = trim($this->corpoNF["CDESTAIBGEEMIT"]);
        $cNF = substr($this->corpoNF["NRLANCTONF"], 2, 8);
        $natOp = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMTIPOOPER"])));
        $indPag = $this->getFormaPagamento($this->corpoNF["IDENTRSAIDOP"], $this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"], $this->corpoNF["IDORIGDESTNF"], \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTENTRSAID"], new \DateTimeZone('America/Sao_Paulo')));
        $mod = $this->corpoNF["CDMODDOCFISC"];
        $serie = $this->serie;
        $nNF = ltrim($this->getNumeroNotaFiscal(), "0");
        //Data e hora do evento no formato AAAA-MM-DDTHH:MM:SSTZD (UTC)
        $dhEmi = $dtEmi->format("Y-m-d") . 'T' . $dtEmi->format("H:i:s") . $this->timeZone;
        $dhSaiEnt = "";
        if (isset($dtSaiEnt)) {
            $dhSaiEnt = $dtSaiEnt->format("Y-m-d") . 'T' . $dtSaiEnt->format("H:i:s") . $this->timeZone;
        }
        $hSaiEnt = "";
        //        $hSaiEnt = $dSaiEnt"]->format("H:i:s");
        $tpNF = $this->corpoNF["IDENTRSAIDOP"] === Notafiscal::NOTA_FISCAL_ENTRADA ? "0" : "1";

        $cdfisopeitem = Itemproduto::getRepository()->getMaxCDFISOPEITEM($this->corpoNF['CDFILIAL'], $this->corpoNF['NRLANCTONF'], $this->corpoNF['NRORG']);
        if(in_array($cdfisopeitem[0], array('1', '5'))){
            $idDest = '1';
        }
        elseif(in_array($cdfisopeitem[0], array('2', '6'))){
            $idDest = '2';
        }
        else{
            $idDest = '3';
        }

        //Tem cliente da teknisa que o cadastro IBGE do municipio com 5 caracteres e outros com 7 caracteres
        if(strlen(Util::removeMascaraInscricao($this->corpoNF["CDMUNIIBGEEMIT"])) === 7){
            $cMunFG = trim($this->corpoNF["CDMUNIIBGEEMIT"]);
        }else{
            $cMunFG = trim($this->corpoNF["CDESTAIBGEEMIT"]).trim($this->corpoNF["CDMUNIIBGEEMIT"]);
        }

        $tpImp = trim($this->corpoNF["IDTPIMPRESDANFE"]);
        $tpEmis = $this->tipoEmissao;
        $cDV = substr($this->chaveAcesso, 43, 1);
        $tpAmb = $this->tipoAmbiente;
        if($this->corpoNF["IDNFESTCANC"][0] === "S" || $this->corpoNF["IDNFAJUSTE"][0] === "S"){
            $finNFe = "3";
        }else{
            if($this->corpoNF["CDTIPOOPER"] === "03"){
                $finNFe = "2";
            }else{
                if($this->corpoNF['IDOPERDEVONF'] === 'S')
                    $finNFe = "4";
                else{
                    $finNFe = "1";
                }
            }
        }

        $indFinal = '0';
        $indPres  = '9';

        $procEmi = "0";
        $verProc = "TEK_".$this->modulo."_".$this->getFileVersion();
        $dhCont = "";
        $xJust = "";
        if(in_array($this->tipoEmissao[0], array("2", "3", "4", "5", "6", "7"))){
            $dataEmissao = \DateTime::createFromFormat('d/m/Y H:i:s', $this->corpoNF["DTEMISSAO"], new \DateTimeZone('America/Sao_Paulo'));
            $dhCont = $dataEmissao->format("Y-m-d")."T".$dataEmissao->format("H:i:s").$this->timeZone;
            $xJust = "DANFE em Contingencia - impresso em decorrencia de problemas tecnicos";
        }

        $this->txtStructure[] = "B|$cUF|$cNF|$natOp|$indPag|$mod|$serie|$nNF|$dhEmi|$dhSaiEnt|$hSaiEnt|$tpNF|$cMunFG|$idDest|$tpImp|$tpEmis|$cDV|$tpAmb|$finNFe|$procEmi|$verProc|$dhCont|$xJust|";

        $ide = $this->DOM->createElement("ide");
        $ide->appendChild($this->DOM->createElement("cUF", $cUF));
        $ide->appendChild($this->DOM->createElement("cNF", $cNF));
        $ide->appendChild($this->DOM->createElement("natOp", $natOp));
        $ide->appendChild($this->DOM->createElement("indPag", $indPag));
        $ide->appendChild($this->DOM->createElement("mod", $mod));
        $ide->appendChild($this->DOM->createElement("serie", $serie));
        $ide->appendChild($this->DOM->createElement("nNF", $nNF));
        $ide->appendChild($this->DOM->createElement("dhEmi", $dhEmi));
        if(!empty($dhSaiEnt)) {
            $ide->appendChild($this->DOM->createElement("dhSaiEnt", $dhSaiEnt));
            if(!empty($hSaiEnt))
                $ide->appendChild($this->DOM->createElement("hSaiEnt", $hSaiEnt));
        }
        $ide->appendChild($this->DOM->createElement("tpNF", $tpNF));
        $ide->appendChild($this->DOM->createElement("idDest", $idDest));
        $ide->appendChild($this->DOM->createElement("cMunFG", $cMunFG));
        $tpImp = $this->DOM->createElement("tpImp", $tpImp);
        $ide->appendChild($tpImp);
        $ide->appendChild($this->DOM->createElement("tpEmis", $tpEmis));
        $ide->appendChild($this->DOM->createElement("cDV", $cDV));
        $ide->appendChild($this->DOM->createElement("tpAmb", $tpAmb));
        $ide->appendChild($this->DOM->createElement("finNFe", $finNFe));
        $ide->appendChild($this->DOM->createElement("indFinal", $indFinal));
        $ide->appendChild($this->DOM->createElement("indPres", $indPres));
        $ide->appendChild($this->DOM->createElement("procEmi", $procEmi));
        $ide->appendChild($this->DOM->createElement("verProc", $verProc));
        if(!empty($dhCont) || !empty($xJust)) {
            $ide->appendChild($this->DOM->createElement("dhCont", $dhCont));
            $ide->appendChild($this->DOM->createElement("xJust", $xJust));
        }

        $this->tags["infNFe"]->appendChild($ide);

        if($this->corpoNF['IDOPERDEVONF'] === 'S' || $this->corpoNF['CDTIPOOPER'] === '03' || $this->corpoNF['IDNFESTCANC'] === 'S'){
            $resultSetNotaDevolucao = \Geral\Entities\Itemnotafisc::getRepository()->consultaDevolucaoNF($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"]);
            //            $resultSetNotaDevolucao = $this->repository->get("nfeTransNotaDevolucao");
            foreach($resultSetNotaDevolucao as $rowNotaDevo){
                if(!empty($rowNotaDevo["NRACESSONFE"])){
                    $refNFe = $rowNotaDevo["NRACESSONFE"];
                    if (!isset($this->tags["NFref"])) {
                        $this->tags["NFref"] = $this->DOM->createElement("NFref");
                        $ide->insertBefore($ide->appendChild($this->tags["NFref"]),$tpImp);
                    }

                    $this->tags["NFref"]->appendChild($this->DOM->createElement("refNFe", $refNFe));

                    $this->txtStructure[] = "B13|$refNFe|";
                }else{
                    $cUF = trim($this->corpoNF["CDESTAIBGEEMIT"]);
                    $AAMM = \DateTime::createFromFormat('d/m/Y H:i:s', $rowNotaDevo["DTEMISSAO"], new \DateTimeZone('America/Sao_Paulo'))->format("Ym");
                    $CNPJ = trim(Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"]));
                    $mod = "01";
                    $serie = $rowNotaDevo["CDSERIE"];
                    $nNF = empty($nNF) ? 1 : $nNF = ltrim($rowNotaDevo["NRNOTAFISC"], "0");

                    if (!isset($this->tags["NFref"])) {
                        $this->tags["NFref"] = $this->DOM->createElement("NFref");
                        $ide->insertBefore($ide->appendChild($this->tags["NFref"]),$tpImp);
                    }

                    $refNF = $this->DOM->createElement("refNF");
                    $refNF->appendChild($this->createElement("cUF", $cUF));
                    $refNF->appendChild($this->createElement("AAMM", $AAMM));
                    $refNF->appendChild($this->createElement("CNPJ", $CNPJ));
                    $refNF->appendChild($this->createElement("mod", $mod));
                    $refNF->appendChild($this->createElement("serie", $serie));
                    $refNF->appendChild($this->createElement("nNF", $nNF));
                    $this->tags["NFref"]->appendChild($refNF);

                    $this->txtStructure[] = "B14|$cUF|$AAMM|$CNPJ|$mod|$serie|$nNF|";
                }
            }
        }

        //Verificando a existência de Notas Referenciadas para Produtor Rural
        $resultSetProdutorRural = \Indeterminado\Entities\Nfprodrural::getRepository()->consultaNotaFiscal($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"], $this->corpoNF["NRORG"]);
        //   $resultSetProdutorRural = $this->repository->get("nfeTransNotaProdRural");
        if ($resultSetProdutorRural){
            $itProdRural = $resultSetProdutorRural->getIterator();
            while($itProdRural->valid()){
                $rowProdutorRural = $itProdRural->current();
                $cUF = $rowProdutorRural["CDESTADOIBGE"];
                $AAMM = \DateTime::createFromFormat('d/m/Y H:i:s', $rowProdutorRural["DTEMISSAO"], new \DateTimeZone('America/Sao_Paulo'))->format("Ym");
                $IE = $rowProdutorRural["CDINSCESTA"];
                $mod = $rowProdutorRural["CDMODDOCFISC"];
                $serie = $rowProdutorRural["CDSERIE"];
                $nNF = ltrim($rowProdutorRural["NRNOTAFISC"], "0");

                $dados[] = "B20a|$cUF|$AAMM|$IE|$mod|$serie|$nNF|";

                if (!isset($this->tags["NFref"])) {
                    $this->tags["NFref"] = $this->DOM->createElement("NFref");
                    $ide->insertBefore($ide->appendChild($this->tags["NFref"]),$tpImp);
                }

                $refNFP = $this->DOM->createElement("refNFP");
                $refNFP->appendChild($this->DOM->createElement("cUF", $cUF));
                $refNFP->appendChild($this->DOM->createElement("AAMM", $AAMM));
                $refNFP->appendChild($this->DOM->createElement("IE", $IE));
                $refNFP->appendChild($this->DOM->createElement("mod", $mod));
                $refNFP->appendChild($this->DOM->createElement("serie", $serie));
                $refNFP->appendChild($this->DOM->createElement("nNF", $nNF));
                $this->tags["NFref"]->appendChild($refNFP);

                if($rowProdutorRural['IDTPINSCJUR'] === "J"){
                    $CNPJ = trim(Util::removeMascaraInscricao($rowProdutorRural["NRINSJURIEST"]));
                    if(!isset($refNFP)){
                        $refNFP->appendChild($this->DOM->createElement("CNPJ", $CNPJ));
                    }
                    $this->txtStructure[] = "B20d|$CNPJ";
                }elseif($rowProdutorRural['IDTPINSCJUR'] === "F"){
                    $CPF = trim(Util::removeMascaraInscricao($rowProdutorRural["NRINSJURIEST"]));
                    if(!isset($refNFP)){
                        $refNFP->appendChild($this->DOM->createElement("CPF", $CPF));
                    }
                    $this->txtStructure[] = "B20e|$CPF";
                }

                $itProdRural->next();
            }
        }

        // Cupom Fiscal
        //        $resultSetCupomFiscal = \Fiscal\Entities\Dadosnf::getRepository()->consultaCupomFiscal($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"]);
        $dstCupomFiscal = $this->repository->get("nfeTransConsultaCupomFiscal");
        if($dstCupomFiscal && !$dstCupomFiscal->isEmpty()){
            $rowCupomFiscal = $dstCupomFiscal->first();
            $mod = "2D";
            $nECF = $rowCupomFiscal["NRECFCUPOMNF"];
            $nCOO = $rowCupomFiscal["NRCOOCUPOMNF"];
            if (!isset($this->tags["NFref"])) {
                $this->tags["NFref"] = $this->DOM->createElement("NFref");
                $ide->insertBefore($ide->appendChild($this->tags["NFref"]),$tpImp);
            }
            $refECF = $this->DOM->createElement("refECF");
            $refECF->appendChild($this->DOM->createElement("mod", $mod));
            $refECF->appendChild($this->DOM->createElement("nECF", $nECF));
            $refECF->appendChild($this->DOM->createElement("nCOO", $nCOO));
            $this->tags["NFref"]->appendChild($refECF);

            $this->txtStructure[] = "B20j|$mod|$nECF|$nCOO|";
        }

    }

    private function geraNumeroNotaFiscal()
    {
        if(empty($this->corpoNF["NRNOTAFISCALELE"])){
            $number = Notafiscal::geraNovoCodigoNFE(
                $this->corpoNF["NRORG"], $this->corpoNF["CDEMPRESA"], preg_replace("/\s+/", "",Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"])),
                $this->serie, $this->tipoAmbiente
            );
        }else{
            if(($this->corpoNF["IDTIPOEMISNFE"] === "1" && $this->modoTransmissao === Notafiscal::MODO_SERIE_SCAN) || ($this->corpoNF["IDTIPOEMISNFE"] === "3" && $this->modoTransmissao === Notafiscal::MODO_SERIE_NORMAL)){
                $number = Notafiscal::geraNovoCodigoNFE(
                    $this->corpoNF["NRORG"], $this->corpoNF["CDEMPRESA"], preg_replace("/\s+/", "",Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"])),
                    $this->serie, $this->tipoAmbiente
                );
            }else{
                $number = $this->corpoNF["NRNOTAFISCALELE"];
            }
        }

        return $number;
    }

    private function criaTagEmitente()
    {
        //Preenche os dados do emitente
        $xNome = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMRAZSOCEMIT"])));
        $xFant = $xNome;

        if(strpos("ISENTO",strtoupper($this->corpoNF["NRINSCESTEMIT"])) || strpos("ISENTA", strtoupper($this->corpoNF["NRINSCESTEMIT"]))){
            $IE = "ISENTO";
        }else{
            $IE = str_replace(" ", "", Util::removeMascaraInscricao(Util::removeAcentos($this->corpoNF["NRINSCESTEMIT"])));
        }
        $IEST = "";
        if(!empty($this->corpoNF["CDINSCESTAST"])){
            $IE = str_replace(" ", "", Util::removeMascaraInscricao(Util::removeAcentos($this->corpoNF["CDINSCESTAST"])));
            $IEST = $IE;
        }
        $resultSetItemProImpos = Itemproimpos::getRepository()->consultaItemProdutoImpostoNFE($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"], "31", $this->corpoNF["NRORG"]);
        //   $resultSetItemProImpos = $this->repository->get("nfeTransConsultaProdutoImpostoNFE");
        $IM = "";
        $CNAE = "";
        if ($resultSetItemProImpos && !$resultSetItemProImpos->isEmpty()) {
            // Nao eh necessario verificar se os mesmos estao vazios no array, pois tal validacao eh feita na class ValidaNFE, ln - 310/322
            $IM = trim(Util::removeMascaraInscricao(Util::removeAcentos($this->corpoNF["CDINSCMUNI"])));
            $CNAE = str_pad(trim(Util::removeMascaraInscricao(Util::removeAcentos($this->corpoNF["CDCNAE"]))), 7, "0");
        }

        $CRT = Parametros::getSituacaoCRT();
        $this->txtStructure[] = "C|$xNome|$xFant|$IE|$IEST|$IM|$CNAE|$CRT|";

        $this->tags["emit"] = $this->DOM->createElement("emit");
        $xNome = $this->DOM->createElement("xNome", $xNome);
        $this->tags["emit"]->appendChild($xNome);
        if(!empty($xFant)) {
            $this->tags["emit"]->appendChild($this->DOM->createElement("xFant", $xFant));
        }
        $this->tags["IE"] = $this->DOM->createElement("IE", $IE);
        $this->tags["emit"]->appendChild($this->tags["IE"]);
        if(!empty($IEST)) {
            $this->tags["emit"]->appendChild($this->DOM->createElement("IEST", $IEST));
        }
        if(!empty($IM)) {
            $this->tags["emit"]->appendChild($this->DOM->createElement("IM", $IM));
        }
        if(!empty($CNAE)) {
            $this->tags["emit"]->appendChild($this->DOM->createElement("CNAE", $CNAE));
        }
        if(!empty($CRT)) {
            $this->tags["emit"]->appendChild($this->DOM->createElement("CRT", $CRT));
        }

        $this->tags["infNFe"]->appendChild($this->tags["emit"]);

        if ($this->corpoNF["IDTPIJUREMIT"] === 'F'){
            $CPF = str_pad($this->corpoNF["NRINSJUREMIT"], 11, "0");
            $this->txtStructure[] = "C02a|$CPF|";
            $this->tags["emit"]->insertBefore($this->tags["emit"]->appendChild($this->DOM->createElement("CPF", $CPF)),$xNome);
        }else{
            if ($this->corpoNF["CDPAISBACENEMIT"] === '1058') {
                $cnpjEmitente = Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"]);
            } else {
                //Caso o emitente nao seja do brasil (caso de notas de importação)
                $cnpjEmitente = Util::removeMascaraInscricao($this->corpoNF["NRINSJUREMIT"]);
                $cnpjEmitente = str_pad(trim(substr($cnpjEmitente, strlen($cnpjEmitente)-14, 14)), 14, "0");
            }

            $this->txtStructure[] = "C02|$cnpjEmitente|";
            $this->tags["emit"]->insertBefore($this->tags["emit"]->appendChild($this->DOM->createElement("CNPJ", $cnpjEmitente)),$xNome);
        }

        //Preenche os dados do endereço do emitente
        $this->criaTagEnderecoEmitente();
    }

    private function criaTagEnderecoEmitente()
    {
        $xLgr = "";
        if (!empty($this->corpoNF["DSENDEEMIT"])) {
            $xLgr = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSENDEEMIT"])));
        }
        //@TODO (FACILITIES) - Verificar cadastro de numero
        $nro = ".";
        $xBairro = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMBAIREMIT"])));
        if ($this->corpoNF["CDPAISBACENEMIT"] === "1058") {
            if (strlen(Util::removeMascaraInscricao($this->corpoNF["CDMUNIIBGEEMIT"])) === 7) {
                $cMun = trim($this->corpoNF["CDMUNIIBGEEMIT"]);
            } else {
                $cMun = trim($this->corpoNF["CDESTAIBGEEMIT"]) . trim($this->corpoNF["CDMUNIIBGEEMIT"]);
            }

            $xMun = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMMUNIEMIT"])));
            $UF = trim($this->corpoNF["SGESTAEMIT"]);
        } else {
            //Operacao do exterior
            $cMun = '9999999';
            $xMun = 'EXTERIOR';
            $UF = 'EX';
        }

        $CEP = str_pad(Util::removeCharsFromString($this->corpoNF["NRCEPEMIT"]), 8, "0");
        $cPais = trim($this->corpoNF["CDPAISBACENEMIT"]);
        $xPais = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMPAISEMIT"])));
        $fone = Util::removeCharsFromString($this->corpoNF["NRTELEEMIT"]);
        $fone = substr($fone, strlen($fone) - 10, 10);
        $xCpl = "";

        $this->txtStructure[] = "C05|$xLgr|$nro|$xCpl|$xBairro|$cMun|$xMun|$UF|$CEP|$cPais|$xPais|$fone|";

        $enderEmi = $this->DOM->createElement("enderEmit");
        $xLgr = $this->DOM->createElement("xLgr", $xLgr);
        $enderEmi->appendChild($xLgr);
        // $nro=abs((int)$nro);
        $nro = $this->DOM->createElement("nro", $nro);
        $enderEmi->appendChild($nro);
        if(!empty($xCpl)) {
            $xCpl = $this->DOM->createElement("xCpl", $xCpl);
            $enderEmi->appendChild($xCpl);
        }
        $xBairro = $this->DOM->createElement("xBairro", $xBairro);
        $enderEmi->appendChild($xBairro);
        $cMun = $this->DOM->createElement("cMun", $cMun);
        $enderEmi->appendChild($cMun);
        $xMun = $this->DOM->createElement("xMun", $xMun);
        $enderEmi->appendChild($xMun);
        $UF = $this->DOM->createElement("UF", $UF);
        $enderEmi->appendChild($UF);
        if(!empty($CEP)) {
            $CEP = $this->DOM->createElement("CEP", $CEP);
            $enderEmi->appendChild($CEP);
        }
        if(!empty($cPais)) {
            $cPais = $this->DOM->createElement("cPais", $cPais);
            $enderEmi->appendChild($cPais);
        }
        if(!empty($xPais)) {
            $xPais = $this->DOM->createElement("xPais", $xPais);
            $enderEmi->appendChild($xPais);
        }
        if(!empty($fone)) {
            $fone = $this->DOM->createElement("fone", $fone);
            $enderEmi->appendChild($fone);
        }
        $this->tags["emit"]->insertBefore($this->tags["emit"]->appendChild($enderEmi),$this->tags["IE"]);
    }

    private function criaTagDestinatario()
    {
        // Cupom Fiscal
        // $resultSetCupomFiscal = \Fiscal\Entities\Dadosnf::getRepository()->consultaCupomFiscal($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"]);
        $dstCupomFiscal = $this->repository->get("nfeTransConsultaCupomFiscal");
        // Preenche os dados do destinatario.
        $ISUF = "";
        $email = "";
        $idEstrangeiro = '';

        // Rotina colocada para geração das notas vindas de um cupom fiscal
        if($dstCupomFiscal){
            $resultSetCupomFiscal = $dstCupomFiscal->first();
            //Verificar se o destinatario e do exterior
            //Codigo 1058 é o cóigo do brasil de acordo com o codigo do banco central
            //Quando for cliente do Exterior nao passar o CPF e nem o CNPJ
            $this->tags["dest"] = $this->DOM->createElement("dest");
            if($this->tipoAmbiente === "1"){
                if($resultSetCupomFiscal["CDPAISBACEN"] === "1058"){
                    if($resultSetCupomFiscal["IDTPIJUDESNF"] === "F"){
                        $CPF = $this->DOM->createElement("CPF", trim(Util::removeMascaraInscricao($resultSetCupomFiscal["NRINSJUDESNF"])));
                    }else{
                        $CNPJ = $this->DOM->createElement("CNPJ", trim(Util::removeMascaraInscricao($resultSetCupomFiscal["NRINSJUDESNF"])));
                    }
                }else{
                    //                        $CNPJ = $this->DOM->createElement("CNPJ", "");
                    $idEstrangeiro = $this->DOM->createElement("idEstrangeiro", trim(Util::removeMascaraInscricao($resultSetCupomFiscal["NRINSJURDESNF"])));
                }

                if($this->corpoNF["IDBRINDETPOPER"] === "N"){
                    $xNome = trim($this->replaceCharsForParser(Util::removeAcentos($resultSetCupomFiscal["NMRAZSODESNF"])));
                }else{
                    if($this->corpoNF["IDENTRSAIDOP"] === "S"){
                        $xNome = 'Diversos – Remessa de Brindes';
                    }else{
                        $xNome = 'Diversos – Brindes';
                    }
                }
                if(strpos("ISENTO",strtoupper($resultSetCupomFiscal['NRINSESTDESNF'])) || strpos("ISENTA", strtoupper($resultSetCupomFiscal['NRINSESTDESNF']))){
                    $indIEDest = '2';
                }elseif($resultSetCupomFiscal['NRINSESTDESNF']){
                    $indIEDest = '1';
                    $IE = str_replace(" ", "", Util::removeMascaraInscricao(Util::removeAcentos($resultSetCupomFiscal['NRINSESTDESNF'])));
                }
                else{
                    $indIEDest = '9';
                }
                $xNome = $this->DOM->createElement("xNome", $xNome);
                $this->tags["dest"]->appendChild($xNome);
                $indIEDest = $this->DOM->createElement("indIEDest", $indIEDest);
                $this->tags["dest"]->appendChild($indIEDest);
                if(isset($IE)){
                    $IE = $this->DOM->createElement("IE", $IE);
                    $this->tags["dest"]->appendChild($IE);
                }
                if (isset($CPF)) {
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($CPF),$xNome);
                }
                elseif(isset($CNPJ)) {
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($CNPJ),$xNome);
                }
                else{
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($idEstrangeiro),$xNome);
                }
            }else{
                if($this->corpoNF["CDPAISBACENCLIE"] === "1058"){
                    $CNPJ = $this->DOM->createElement("CNPJ", "99999999000191");
                }else{
                    //                        $CNPJ = $this->DOM->createElement("CNPJ", "");
                    $idEstrangeiro = $this->DOM->createElement("idEstrangeiro", '99999999999');
                }

                $xNome = $this->DOM->createElement("xNome", 'NF-E EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM VALOR FISCAL');
                $this->tags["dest"]->appendChild($xNome);
                $indIEDest = $this->DOM->createElement("indIEDest", '9');
                $this->tags["dest"]->appendChild($indIEDest);
                //                    $IE = $this->DOM->createElement("IE", '');
                //                    $this->tags["dest"]->appendChild($IE);
                if(isset($CNPJ)){
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($CNPJ),$xNome);
                }
                else{
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($idEstrangeiro),$xNome);
                }
            }

            if(!empty($ISUF)) {
                $ISUF = $this->DOM->createElement("ISUF", $ISUF);
                $this->tags["dest"]->appendChild($ISUF);
            }
            if(!empty($email)) {
                $email = $this->DOM->createElement("email", $email);
                $this->tags["dest"]->appendChild($email);
            }
            $this->tags["infNFe"]->appendChild($this->tags["dest"]);

            $this->criaTagEnderecoDestinatarioCupomFiscal($resultSetCupomFiscal);
        }else{
            $ISUF = trim($this->corpoNF["NRINSCSUFRAMA"]);
            if(!empty($this->corpoNF["DSEMAILDEST"])){
                $dsEmail = trim($this->corpoNF['DSEMAILDEST']);
                $email = str_replace(",",";", $dsEmail);
                $posVirg = strpos(";", $dsEmail);
                if($posVirg){
                    $email = substr($email, 0, $posVirg);
                }
                // length(stEmail) <= 60
                $email = strlen($email) > 60 ? "" : $email;
            }
            $this->tags["dest"] = $this->DOM->createElement("dest");
            //Verificar se o destinatario e do exterior
            //Codigo 1058 é o cóigo do brasil de acordo com o codigo do banco central
            //Quando for cliente do Exterior nao passar o CPF e nem o CNPJ
            if($this->tipoAmbiente === "1"){
                if($this->corpoNF["CDPAISBACENCLIE"] === "1058"){
                    if($this->corpoNF["IDTPIJURCLIE"] === "F"){
                        $CPF = $this->DOM->createElement("CPF", Util::removeMascaraInscricao($this->corpoNF["NRINSJURCLIE"]));
                    }else{
                        $CNPJ = $this->DOM->createElement("CNPJ", trim(Util::removeMascaraInscricao($this->corpoNF["NRINSJURCLIE"])));
                    }
                }else{
                    //                        $CNPJ = $this->DOM->createElement("CNPJ", "");
                    $idEstrangeiro = $this->DOM->createElement("idEstrangeiro", trim(Util::removeMascaraInscricao($this->corpoNF['NRINSJURCLIE'])));
                }

                if($this->corpoNF["IDBRINDETPOPER"] === "N"){
                    $xNome = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMRAZSOCCLIE"])));
                }else{
                    if($this->corpoNF["IDENTRSAIDOP"] === "S"){
                        $xNome = 'Diversos – Remessa de Brindes';
                    }else{
                        $xNome = 'Diversos – Brindes';
                    }
                }
                if($this->corpoNF['NRINSCESTCLIE']){
                    if(strpos("ISENTO",strtoupper($this->corpoNF["NRINSCESTCLIE"])) || strpos("ISENTA", strtoupper($this->corpoNF["NRINSCESTCLIE"]))) {
                        $indIEDest = '2';
                    }
                    else{
                        $indIEDest = '1';
                        $IE = str_replace(" ", "", Util::removeMascaraInscricao(Util::removeAcentos($this->corpoNF["NRINSCESTCLIE"])));
                    }
                }
                else{
                    $indIEDest = '9';
                }

                $xNome = $this->DOM->createElement("xNome", $xNome);
                $this->tags["dest"]->appendChild($xNome);
                $this->tags["indIEDest"] = $this->DOM->createElement("indIEDest", $indIEDest);
                $this->tags["dest"]->appendChild($this->tags["indIEDest"]);
                if(isset($IE)){
                    $this->tags["IE"] = $this->DOM->createElement("IE", $IE);
                    $this->tags["dest"]->appendChild($this->tags["IE"]);
                }
                if (isset($CPF)) {
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($CPF),$xNome);
                }
                elseif(isset($CNPJ)) {
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($CNPJ),$xNome);
                }
                else{
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($idEstrangeiro),$xNome);
                }
            }else{
                if($this->corpoNF["CDPAISBACENCLIE"] === "1058"){
                    $CNPJ = $this->DOM->createElement("CNPJ", "99999999000191");
                }else{
                    //                        $CNPJ = $this->DOM->createElement("CNPJ", "");
                    $idEstrangeiro = $this->DOM->createElement("idEstrangeiro", "99999999999");
                }

                $xNome = $this->DOM->createElement("xNome", 'NF-E EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM VALOR FISCAL');
                $this->tags["dest"]->appendChild($xNome);
                $this->tags['indIEDest'] = $this->DOM->createElement("indIEDest", '9');
                $this->tags["dest"]->appendChild($this->tags['indIEDest']);
                //                    $this->tags["IE"] = $this->DOM->createElement("IE", '');
                //                    $this->tags["dest"]->appendChild($this->tags["IE"]);
                if(isset($CNPJ)){
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($CNPJ),$xNome);
                }
                else{
                    $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($idEstrangeiro),$xNome);
                }
            }

            if(!empty($ISUF)) {
                $ISUF = $this->DOM->createElement("ISUF", $ISUF);
                $this->tags["dest"]->appendChild($ISUF);
            }
            if(!empty($email)) {
                $email = $this->DOM->createElement("email", $email);
                $this->tags["dest"]->appendChild($email);
            }
            $this->tags["infNFe"]->appendChild($this->tags["dest"]);

            $this->criaTagEnderecoDestinatarioCorpoNF();
        }
        //Fim do destinatario
    }

    private function criaTagEnderecoDestinatarioCorpoNF()
    {
        //Preenche o endereço do destinatario
        $xLgr = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSENDECLIE"])));
        $nro = ".";
        $xCpl = "";
        if (!empty($this->corpoNF["DSCOMPENDCLI"])) {
            $xCpl = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSCOMPENDCLI"])));
        }
        $xBairro = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMBAIRCLIE"])));
        $xMun = "";
        if ($this->corpoNF["CDPAISBACENCLIE"] === "1058") {
            if (strlen(Util::removeMascaraInscricao($this->corpoNF["CDMUNIIBGECLIE"])) === 7) {
                $cMun = $this->corpoNF["CDMUNIIBGECLIE"];
            } else {
                $cMun = $this->corpoNF["CDESTAIBGECLIE"] . $this->corpoNF["CDMUNIIBGECLIE"];
            }
            if (!empty($this->corpoNF["NMMUNICLIE"])) {
                $xMun = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMMUNICLIE"])));
            }
            $UF = trim($this->corpoNF["SGESTACLIE"]);
        } else {
            $cMun = '9999999';
            $xMun = 'EXTERIOR';
            $UF = 'EX';
        }

        $CEP = "";
        if (!empty($this->corpoNF["NRCEPCLIE"])) {
            $CEP = str_replace(" ", "", str_pad(Util::removeMascaraInscricao($this->corpoNF["NRCEPCLIE"]), 8, "0"));
        }
        $cPais = trim($this->corpoNF["CDPAISBACENCLIE"]);
        if (!empty($this->corpoNF["NMPAISCLIE"])) {
            $xPais = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMPAISCLIE"])));
        }
        $fone = Util::removeCharsFromString($this->corpoNF["NRTELECLIE"]);
        if (!empty($fone)) {
            $fone = substr($fone, strlen($fone) - 10, 10);
        }

        try{
            $enderDest = $this->DOM->createElement("enderDest");
            $xLgr = $this->DOM->createElement("xLgr", $xLgr);
            $enderDest->appendChild($xLgr);
            // $nro = abs((int)$nro);
            $nro = $this->DOM->createElement("nro", $nro);
            $enderDest->appendChild($nro);
            if(!empty($xCpl)){
                $xCpl = $this->DOM->createElement("xCpl", $xCpl);
                $enderDest->appendChild($xCpl);
            }
            $xBairro = $this->DOM->createElement("xBairro", $xBairro);
            $enderDest->appendChild($xBairro);
            $cMun = $this->DOM->createElement("cMun", $cMun);
            $enderDest->appendChild($cMun);
            $xMun = $this->DOM->createElement("xMun", $xMun);
            $enderDest->appendChild($xMun);
            $UF = $this->DOM->createElement("UF", $UF);
            $enderDest->appendChild($UF);
            if(!empty($CEP)){
                $CEP = $this->DOM->createElement("CEP", $CEP);
                $enderDest->appendChild($CEP);
            }
            if(!empty($cPais)){
                $cPais = $this->DOM->createElement("cPais", $cPais);
                $enderDest->appendChild($cPais);
            }
            if(!empty($xPais)){
                $xPais = $this->DOM->createElement("xPais", $xPais);
                $enderDest->appendChild($xPais);
            }
            if(!empty($fone)){
                $fone = $this->DOM->createElement("fone", $fone);
                $enderDest->appendChild($fone);
            }
            $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($enderDest),$this->tags["indIEDest"]);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    private function criaTagEnderecoDestinatarioCupomFiscal($resultSetCupomFiscal)
    {
        //Preenche o endereço do destinatario
        $fone = "";
        $xCpl = "";
        $xLgr = trim($this->replaceCharsForParser(Util::removeAcentos($resultSetCupomFiscal["DSENDEDESTNF"])));
        $nro = ".";
        $xBairro = trim($this->replaceCharsForParser(Util::removeAcentos($resultSetCupomFiscal["NMBAIRDESTNF"])));
        if ($resultSetCupomFiscal["CDPAISBACEN"] === "1058") {
            if (strlen(Util::removeMascaraInscricao($resultSetCupomFiscal["CDMUNICIBGE"])) === 7) {
                $cMun = $resultSetCupomFiscal["CDMUNICIBGE"];
            } else {
                $cMun = $resultSetCupomFiscal["CDESTADOIBGE"] . $resultSetCupomFiscal["CDMUNICIBGE"];
            }

            $xMun = "";
            if (!empty($resultSetCupomFiscal["NMMUNICIPIO"])) {
                $xMun = trim($this->replaceCharsForParser(Util::removeAcentos($resultSetCupomFiscal["NMMUNICIPIO"])));
            }

            $UF = trim($resultSetCupomFiscal["SGESTADO"]);
        } else {
            $cMun = '9999999';
            $xMun = 'EXTERIOR';
            $UF = 'EX';
        }

        $cPais = trim($resultSetCupomFiscal["CDPAISBACEN"]);
        if (!empty($resultSetCupomFiscal["NMPAIS"])) {
            $xPais = trim($this->replaceCharsForParser(Util::removeAcentos($resultSetCupomFiscal["NMPAIS"])));
        }

        $enderDest = $this->DOM->createElement("enderDest");
        $xLgr = $this->DOM->createElement("xLgr", $xLgr);
        $enderDest->appendChild($xLgr);
        // $nro = abs((int)$nro);
        $nro = $this->DOM->createElement("nro", $nro);
        $enderDest->appendChild($nro);
        if(!empty($xCpl)){
            $xCpl = $this->DOM->createElement("xCpl", $xCpl);
            $enderDest->appendChild($xCpl);
        }
        $xBairro = $this->DOM->createElement("xBairro", $xBairro);
        $enderDest->appendChild($xBairro);
        $cMun = $this->DOM->createElement("cMun", $cMun);
        $enderDest->appendChild($cMun);
        $xMun = $this->DOM->createElement("xMun", $xMun);
        $enderDest->appendChild($xMun);
        $UF = $this->DOM->createElement("UF", $UF);
        $enderDest->appendChild($UF);
        if(!empty($CEP)){
            $CEP = $this->DOM->createElement("CEP", $CEP);
            $enderDest->appendChild($CEP);
        }
        if(!empty($cPais)){
            $cPais = $this->DOM->createElement("cPais", $cPais);
            $enderDest->appendChild($cPais);
        }
        if(!empty($xPais)){
            $xPais = $this->DOM->createElement("xPais", $xPais);
            $enderDest->appendChild($xPais);
        }
        if(!empty($fone)){
            $fone = $this->DOM->createElement("fone", $fone);
            $enderDest->appendChild($fone);
        }
        $this->tags["dest"]->insertBefore($this->tags["dest"]->appendChild($enderDest),$this->tags["IE"]);

    }

    private function criaTagItensNotafiscal()
    {
        // Grupo do detalhamento de Produtos e Serviços da NF-e [infNFe] [H]
        $infoProd = "";
        $dstDadosadic = new Dataset(Dadosadic::getObjectsByWhere("CDFILIAL = ? AND NRLANCTONF = ?", array($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"])));

        if(!$dstDadosadic->isEmpty()){
            $itDadosAdic = $dstDadosadic->getIterator();
            while($itDadosAdic->valid()){
                $objDadosAdic = $itDadosAdic->current();
                if( strpos("NUMERO DA ORDEM DO PEDIDO", strtoupper($objDadosAdic->getDsdadoadic())) ||
                    strpos("NÚMERO DA ORDEM DO PEDIDO", strtoupper($objDadosAdic->getDsdadoadic())) ){
                    $infoProd = substr($objDadosAdic->getDsdadoadic(), strpos("|", $objDadosAdic->getDsdadoadic()), strlen(trim($objDadosAdic->getDsdadoadic())));
                }

                $this->info = Util::convertISOToUTF8(trim(Util::removeAcentos($this->info . " " . $objDadosAdic->getDsdadoadic())));

                $itDadosAdic->next();
            }
        }


        //Preenche os dados dos itens da nota
        $dstItemprod = new Dataset(Itemproduto::getRepository()->consultaItemNFE($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"], $this->corpoNF["CDPAISCLIE"], $this->corpoNF["SGESTACLIE"]));
        $itItemprod = $dstItemprod->getIterator();
        while($itItemprod->valid()){
            $rowItemProd = $itItemprod->current();
            $nItem = ltrim($rowItemProd["NRITEM"], "0");

            $this->txtStructure[] = "H|$nItem|$infoProd";

            $this->tags["det"] = $this->DOM->createElement("det");
            $this->tags["det"]->setAttribute("nItem", $nItem);
            if(!empty($infoProd)) {
                $infAdProd = $this->DOM->createElement("infAdProd", $infoProd);
                $this->tags["det"]->appendChild($infAdProd);
            }
            $this->tags["infNFe"]->appendChild($this->tags["det"]);

            $this->criaTagProdutoServico($rowItemProd);
            if ($rowItemProd["IDSEGMENTOPROD"] === "MEDI") {
                $this->criaTagDetalheMedicamentoEMateriasPrimasFarmaceuticas($rowItemProd);
            }

            //GRUPO DE TRIBUTOS INCIDENTES NO PRODUTO SERVICO [M]
            $this->txtStructure[] = "M";
            $this->tags["imposto"] = $this->DOM->createElement("imposto");
            if (!isset($infAdProd)){
                $this->tags["det"]->appendChild($this->tags["imposto"]);
            } else {
                $this->tags["det"]->insertBefore($this->tags["det"]->appendChild($this->tags["imposto"]),$infAdProd);
            }
            $infAdProd = null;
            $dstImpostos = new DataSet(Itemproimpos::getRepository()->consultaDadosImpostosNFE($rowItemProd["CDFILIAL"],$rowItemProd["NRLANCTONF"],$rowItemProd["NRSEQITPROD"]));
            //$dstImpostos = $this->repository->get("nfeTransImposto".$rowItemProd["CDFILIAL"].$rowItemProd["NRLANCTONF"].$rowItemProd["NRSEQITPROD"]);
            if ($dstImpostos) {
                //O grupo ISSQN é mutuamente exclusivo com os grupos ICMS, IPI e II,
                //isto é se ISSQN for informado os grupos ICMS, IPI e II não serão informados e vice-versa (v2.0).
                //Imposto.ISSQN
                $ISSQN = $dstImpostos->find(array("CDIMPOSTONFE" => "31"));
                if($ISSQN){
                    $rowISSQN = $ISSQN->first();
                    $this->criaTagISSQN($rowItemProd, $rowISSQN);
                }else{
                    $this->valorTotalVPROD += Util::decimalToFloat($rowItemProd["VRTOTAITEMFLOAT"]);
                    //Imposto.ICMS
                    $ICMS = $dstImpostos->find(array("CDIMPOSTONFE" => "00"));
                    if ($ICMS) {
                        $rowICMS = $ICMS->first();
                        $this->criaTagICMS($rowItemProd, $rowICMS, $dstImpostos);
                    }
                    //Imposto.IPI
                    $IPI = $dstImpostos->find(array("CDIMPOSTONFE" => "10"));
                    //Para o campo 251 do manual esta sendo passado o valor fixo de '999'
                    if ($IPI) {
                        $rowIPI = $IPI->first();
                        $this->criaTagIPI($rowIPI);
                    }

                    //Imposto.II
                    $II = $dstImpostos->find(array("CDIMPOSTONFE" => "20"));
                    if ($II) {
                        $rowII = $II->first();
                        $this->criaTagII($rowII, $dstImpostos);
                    }
                }

                //Imposto.PIS
                $PIS = $dstImpostos->find(array("CDIMPOSTONFE" => "50"));
                if ($PIS) {
                    $rowPIS = $PIS->first();
                    $this->criaTagPIS($rowPIS, $ISSQN, $dstImpostos);

                }

                //Imposto.COFINS
                $COFINS = $dstImpostos->find(array("CDIMPOSTONFE" => "60"));
                if ($COFINS) {
                    $rowCOFINS = $COFINS->first();
                    $this->criaTagCOFINS($rowCOFINS, $rowItemProd, $dstImpostos);
                }
            }

            // Iterator
            $itItemprod->next();
        }

        $this->criaTagDadosTotais();
        $this->criaTagTransportadora();
        $this->criaTagCobranca();
        $this->criaTagInformacoesAdicionais();
    }

    /**
     * Grupo de Informações do Transporte da NF-e obrigatorio [infNFe] [X]
     */
    private function criaTagTransportadora()
    {
        $this->tags["transp"] = $this->DOM->createElement("transp");

        $this->tags["infNFe"]->appendChild($this->tags["transp"]);
        //Dados transportadora
        if ($this->corpoNF["IDPGTOFRETE"] != '') {
            //@TODO LINHA 6081
            $modFrete = $this->corpoNF["IDPGTOFRETE"];

            $this->txtStructure[] = "X|$modFrete|";

            $modFrete = $this->DOM->createElement("modFrete", $modFrete);
            $this->tags["transp"]->appendChild($modFrete);
            if (!empty($this->corpoNF["NRINSJURTRAN"])) {
                $this->criaTagTransportador();
                $this->criaTagVeiculoTransportadora();
            }
        } else {
            $modFrete = "9";

            $this->txtStructure[] = "X|$modFrete|";

            $modFrete = $this->DOM->createElement("modFrete", $modFrete);
            $this->tags["transp"]->appendChild($modFrete);
        }
    }

    private function criaTagVeiculoTransportadora()
    {
        if (!empty($this->corpoNF["NRPLACAVEIC"])) {
            $placa = trim(strtoupper($this->corpoNF["NRPLACAVEIC"]));
        }

        if (!empty($this->corpoNF["SGUFVEIC"])) {
            $veicUF = trim(strtoupper($this->corpoNF["SGUFVEIC"]));
        }

        $esp = "";
        $marca = "";
        $nVol = "";
        $pesoL = "";
        $pesoB = "";
        $RNTC = "";
        if (!empty($this->corpoNF["DSQTDEVOLU"])) {
            $qVol = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSQTDEVOLU"])));
        }

        if (!empty($this->corpoNF["DSESPECVOLU"])) {
            $esp = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSESPECVOLU"])));
        }

        if (!empty($this->corpoNF["DSMARCAVOLU"])) {
            $marca = trim(strtoupper($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSMARCAVOLU"]))));
        }

        if (!empty($this->corpoNF["DSNUMEVOLU"])) {
            $nVol = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSNUMEVOLU"])));
        }

        if (!empty($this->corpoNF["VRPLIQUVOLU"])) {
            $pesoL = $this->corpoNF["VRPLIQUVOLU"];
        }

        if (!empty($this->corpoNF["VRPBRUTOVOLU"])) {
            $pesoB = $this->corpoNF["VRPBRUTOVOLU"];
        }

        if (isset($placa) && isset($veicUF)) {
            //Grupo Veículo 0 ou 1 [transp] [X18]
            $veicTransp = $this->DOM->createElement("veicTransp");
            $placa = $this->DOM->createElement("placa", $placa);
            $veicTransp->appendChild($placa);
            $UF = $this->DOM->createElement("UF", $veicUF);
            $veicTransp->appendChild($UF);
            if(!empty($RNTC)) {
                $RNTC = $this->DOM->createElement("RNTC", $RNTC);
                $veicTransp->appendChild($RNTC);
            }
            $this->tags["transp"]->appendChild($veicTransp);
        }


        //Grupo Volumes 0 a N [transp] [X26]
        if (isset($qVol)) {
            $vol = $this->DOM->createElement("vol");
            $qVol = $this->DOM->createElement("qVol", $qVol);
            $vol->appendChild($qVol);

            if(!empty($esp)) {
                $esp = $this->DOM->createElement("esp", $esp);
                $vol->appendChild($esp);
            }
            if(!empty($marca)) {
                $marca = $this->DOM->createElement("marca", $marca);
                $vol->appendChild($marca);
            }
            if(!empty($nVol)) {
                $nVol = $this->DOM->createElement("nVol", $nVol);
                $vol->appendChild($nVol);
            }
            if(!empty($pesoL)) {
                $pesoL = $this->DOM->createElement("pesoL", $pesoL);
                $vol->appendChild($pesoL);
            }
            if(!empty($pesoB)) {
                $pesoB = $this->DOM->createElement("pesoB", $pesoB);
                $vol->appendChild($pesoB);
            }
            $this->tags["transp"]->appendChild($vol);
        }
    }

    /**
     * Grupo Transportador 0 ou 1 [transp] [X03]
     */
    private function criaTagTransportador()
    {
        if (!empty($this->corpoNF["NMRAZSOCTRAN"])) {
            $xNome = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMRAZSOCTRAN"])));
        }

        if (!empty($this->corpoNF["NRINSESTTRAN"])) {
            if (strlen(Util::removeMascaraInscricao($this->corpoNF["NRINSESTTRAN"])) >= 2 && strlen(Util::removeMascaraInscricao($this->corpoNF["NRINSESTTRAN"])) <= 14) {
                $IE = Util::removeCharsFromString(Util::removeAcentos($this->corpoNF["NRINSESTTRAN"]));
            }
        }

        if (!empty($this->corpoNF["DSENDETRAN"])) {
            $xEnder = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["DSENDETRAN"])));
        }

        if (!empty($this->corpoNF["NMMUNITRAN"])) {
            $xMun = trim(strtoupper($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMMUNITRAN"]))));
        }

        if (!empty($this->corpoNF["SGESTATRAN"])) {
            $UF = trim(strtoupper($this->corpoNF["SGESTATRAN"]));
        }

        $transporta = $this->DOM->createElement("transporta");
        if(!empty($xNome)) {
            $xNome = $this->DOM->createElement("xNome", $xNome);
            $transporta->appendChild($xNome);
        }
        if(!empty($IE)) {
            $IE = $this->DOM->createElement("IE", $IE);
            $transporta->appendChild($IE);
        }
        if(!empty($xEnder)) {
            $xEnder = $this->DOM->createElement("xEnder", $xEnder);
            $transporta->appendChild($xEnder);
        }
        if(!empty($xMun)) {
            $xMun = $this->DOM->createElement("xMun", $xMun);
            $transporta->appendChild($xMun);
        }
        if(!empty($UF)) {
            $UF = $this->DOM->createElement("UF", $UF);
            $transporta->appendChild($UF);
        }
        $this->tags["transp"]->appendChild($transporta);

        //CPF 0 ou 1 [transporta] [X05]
        if ($this->corpoNF["IDTPIJURTRAN"] === "F") {
            $CPF = Util::removeMascaraInscricao($this->corpoNF["NRINSJURTRAN"]);
            if(!empty($CPF)) {
                $CPF = $this->DOM->createElement("CPF", $CPF);
                $transporta->insertBefore($transporta->appendChild($CPF),$xNome);
            }

        } else {
            //CNPJ 0 ou 1 [transporta] [X04]
            $CNPJ = Util::removeMascaraInscricao($this->corpoNF["NRINSJURTRAN"]);
            $CNPJ = str_pad(substr($CNPJ, strlen($CNPJ) - 14, 14), 14, "0");
            if(!empty($CNPJ)) {
                $CNPJ = $this->DOM->createElement("CNPJ", $CNPJ);
                $transporta->insertBefore($transporta->appendChild($CNPJ),$xNome);
            }
        }
    }

    /**
     * //Grupo do COFINS obrigatório [imposto] [S]
     * @param $rowCOFINS
     * @param $rowItemProd
     * @param $dstImpostos
     */
    private function criaTagCOFINS($rowCOFINS,$rowItemProd, $dstImpostos)
    {
        $this->tags["COFINS"] = $this->DOM->createElement("COFINS");
        $this->tags["imposto"]->appendChild($this->tags["COFINS"]);
        if ($rowCOFINS["CST"] === "01" || $rowCOFINS["CST"] === "02") {
            $this->criaTagCOFINSAliq($rowCOFINS);
        } elseif ($rowCOFINS["CST"] === "03") {
            $this->criaTagCOFINSQtde($rowCOFINS, $rowItemProd);
        } elseif (in_array($rowCOFINS["CST"], array("04", "06", "07", "08", "09"))) {
            $this->criaTagCOFINSNT($rowCOFINS);
        } elseif (in_array($rowCOFINS["CST"], array("05", "49", "50", "51", "52", "53", "54", "55", "56", "60", "61", "62", "63", "64", "65",
                "66", "67", "70", "71", "72", "73", "74", "75", "98", "99"))) {
            $this->criaTagCOFINSOutr($rowCOFINS);
            $this->criaTagCOFINSST($rowCOFINS, $dstImpostos);
        }
    }

    /**
     * [T] & [T02]
     * @param $rowCOFINS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagCOFINSST($rowCOFINS, \Geral\Util\Dataset $dstImpostos)
    {
        //COFINSST
        if (!empty($rowCOFINS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTRIB" => $rowCOFINS["CDIMPOSTRIB"]));
            if ($dstImpostrib) {
                $rowImpostrib = $dstImpostrib->first();
                //                            $qBCProd = $rowImpostrib["QTITEMPROD"];
                //                            $vAliqProd = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTOALIQ"]), 4);
                //Grupo de COFINS Substituição Tributária 0 ou 1 [imposto] [T]
                $vCOFINS = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                //Valor da Base de Cálculo da COFINS e Alíquota da COFINS (em percentual) 0 ou 1 [COFINSST] [T02]
                $vBC = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
                $pCOFINS = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                //Quantidade Vendida e Alíquota da COFINS (em reais) 0 u 1 [COFINSST]
                //                            $this->txtStructure[] = "T04|$qBCProd|$vAliqProd|";
                $COFINSST = $this->DOM->createElement("COFINSST");
                $vCOFINS = $this->DOM->createElement("vCOFINS", $vCOFINS);
                $COFINSST->appendChild($vCOFINS);
                $this->tags["imposto"]->appendChild($COFINSST);
            }
        }
    }

    /**
     * Grupo de COFINS Outras Operações 0 ou 1 [COFINS] [S05]
     * @param $rowCOFINS
     */
    private function criaTagCOFINSOutr($rowCOFINS)
    { //COFINSOutr
        $CST = $rowCOFINS["CST"];
        //                    $qBCProd = $rowItemProd["QTITEMPROD"];
        if ($rowCOFINS["CDFISCALIT"] === "1") {
            //                        $vAliqProd = number_format(Util::decimalToFloat($rowCOFINS["VALORIMPOSTOALIQ"]), 4);
            //Valor da Base de Cálculo da COFINS e Alíquota da COFINS (em percentual) 0 ou 1 [COFINSOutr]
            $vBC = number_format(Util::decimalToFloat($rowCOFINS["BASECALCULO"]), 2, ".", "");
            $pCOFINS = number_format(Util::decimalToFloat($rowCOFINS["ALIQUOTA"]), 2, ".", "");
            //Grupo de COFINS Outras Operações 0 ou 1 [COFINS]
            $vCOFINS = number_format(Util::decimalToFloat($rowCOFINS["VALORIMPOSTO"]), 2, ".", "");
            //COFINS ISSQN
            if (isset($this->tags["ISSQN"])) {
                $this->valorTotalCOFINSISSQN += Util::decimalToFloat($rowCOFINS["VRIMPOSTOIT"]);
            } else {
                $this->valorTotalCOFINS += Util::decimalToFloat($rowCOFINS["VRIMPOSTOIT"]);
            }
        } else {
            //                        $vAliqProd = "0.0000";
            //Valor da Base de Cálculo da COFINS e Alíquota da COFINS (em percentual) 0 ou 1 [COFINSOutr]
            $vBC = "0.00";
            $pCOFINS = "0.00";
            //Grupo de COFINS Outras Operações 0 ou 1 [COFINS]
            $vCOFINS = "0.00";
        }

        //S05|CST|vCOFINS|
        $COFINSOutr = $this->DOM->createElement("COFINSOutr");
        $CST = $this->DOM->createElement("CST", $CST);
        $COFINSOutr->appendChild($CST);
        $vCOFINS = $this->DOM->createElement("vCOFINS", $vCOFINS);
        $COFINSOutr->appendChild($vCOFINS);
        $this->tags["COFINS"]->appendChild($COFINSOutr);

        //S07|vBC|pCOFINS|
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $COFINSOutr->insertBefore($vBC,$vCOFINS);
        $pCOFINS = $this->DOM->createElement("pCOFINS", $pCOFINS);
        $COFINSOutr->insertBefore($pCOFINS,$vCOFINS);
        //Quantidade Vendida e Alíquota da COFINS (em reais) 0 ou 1 [COFINSOutr]
        //                    $this->txtStructure[] = "S09|$qBCProd|$vAliqProd|";
    }

    /**
     * Grupo de COFINS não tributado 0 ou 1 [COFINS] [S04]
     * @param $rowCOFINS
     */
    private function criaTagCOFINSNT($rowCOFINS)
    {
        //COFINSNT
        $CST = $rowCOFINS["CST"];
        $COFINSNT = $this->DOM->createElement("COFINSNT");
        $CST = $this->DOM->createElement("CST", $CST);
        $COFINSNT->appendChild($CST);
        $this->tags["COFINS"]->appendChild($COFINSNT);
    }

    /**
     * Grupo de COFINS tributado por Qtde 0 ou 1 [COFINS] [S03]
     * @param $rowCOFINS
     * @param $rowItemProd
     * @param $ISSQN
     */
    private function criaTagCOFINSQtde($rowCOFINS, $rowItemProd)
    {
        //COFINSQtde
        $CST = $rowCOFINS["CST"];
        $qBCProd = $rowItemProd["QTITEMPROD"];
        if ($rowCOFINS["CDFISCALIT"] === "1") {
            $vAliqProd = number_format(Util::decimalToFloat($rowCOFINS["VALORIMPOSTOALIQ"]), 4, ".", "");
            $vCOFINS = number_format(Util::decimalToFloat($rowCOFINS["VALORIMPOSTO"]), 2, ".", "");
            //COFINS ISSQN
            if (isset($this->tags["ISSQN"])) {
                $this->valorTotalCOFINSISSQN += Util::decimalToFloat($rowCOFINS["VRIMPOSTOIT"]);
            } else {
                $this->valorTotalCOFINS += Util::decimalToFloat($rowCOFINS["VRIMPOSTOIT"]);
            }
        } else {
            $vAliqProd = "0.0000";
            $vCOFINS = "0.00";
        }

        $COFINSQtde = $this->DOM->createElement("COFINSQtde");
        $CST = $this->DOM->createElement("CST", $CST);
        $COFINSQtde->appendChild($CST);
        $qBCProd = $this->DOM->createElement("qBCProd", $qBCProd);
        $COFINSQtde->appendChild($qBCProd);
        $vAliqProd = $this->DOM->createElement("vAliqProd", $vAliqProd);
        $COFINSQtde->appendChild($vAliqProd);
        $vCOFINS = $this->DOM->createElement("vCOFINS", $vCOFINS);
        $COFINSQtde->appendChild($vCOFINS);
        $this->tags["COFINS"]->appendChild($COFINSQtde);
    }

    private function criaTagCOFINSAliq($rowCOFINS)
    {
        //COFINSAliq
        //Grupo de COFINS tributado pela alíquota 0 ou 1 [COFINS]
        $CST = $rowCOFINS["CST"];
        if ($rowCOFINS["CDFISCALIT"] === "1") {
            $vBC = number_format(Util::decimalToFloat($rowCOFINS["BASECALCULO"]), 2, ".", "");
            $pCOFINS = number_format(Util::decimalToFloat($rowCOFINS["ALIQUOTA"]), 2, ".", "");
            $vCOFINS = number_format(Util::decimalToFloat($rowCOFINS["VALORIMPOSTO"]), 2, ".", "");
            //COFINS ISSQN
            if (isset($this->tags["ISSQN"])) {
                $this->valorTotalCOFINSISSQN += Util::decimalToFloat($rowCOFINS["VRIMPOSTOIT"]);
            } else {
                $this->valorTotalCOFINS += Util::decimalToFloat($rowCOFINS["VRIMPOSTOIT"]);
            }
        } else {
            $vBC = "0.00";
            $pCOFINS = "0.00";
            $vCOFINS = "0.00";
        }

        $COFINSAliq = $this->DOM->createElement("COFINSAliq");
        $CST = $this->DOM->createElement("CST", $CST);
        $COFINSAliq->appendChild($CST);
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $COFINSAliq->appendChild($vBC);
        $pCOFINS = $this->DOM->createElement("pCOFINS", $pCOFINS);
        $COFINSAliq->appendChild($pCOFINS);
        $vCOFINS = $this->DOM->createElement("vCOFINS", $vCOFINS);
        $COFINSAliq->appendChild($vCOFINS);
        $this->tags["COFINS"]->appendChild($COFINSAliq);
    }

    /**
     * Grupo do PIS obrigatorio [imposto] [Q]
     * @param $rowPIS
     * @param $ISSQN
     * @param $dstImpostos
     * @return array
     */
    private function criaTagPIS($rowPIS, $ISSQN = null, $dstImpostos)
    {
        $PIS = $this->DOM->createElement("PIS");
        $this->tags["imposto"]->appendChild($PIS);

        if ($rowPIS["CST"] === "01" || $rowPIS["CST"] === "02") {
            //PISAliq [Q02]
            //Grupo de PIS tributado pela alíquota 0 pou 1 [PIS]
            $CST = $rowPIS["CST"];
            if ($rowPIS["CDFISCALIT"] === "1") {
                $vBC = number_format(Util::decimalToFloat($rowPIS["BASECALCULO"]), 2, ".", "");
                $pPIS = number_format(Util::decimalToFloat($rowPIS["ALIQUOTA"]), 2, ".", "");
                $vPIS = number_format(Util::decimalToFloat($rowPIS["VALORIMPOSTO"]), 2, ".", "");
                //PIS ISSQN
                if (isset($this->tags["ISSQN"])) {
                    $this->valorTotalPISISSQN += Util::decimalToFloat($rowPIS["VRIMPOSTOIT"]);
                } else {
                    $this->valorTotalPIS += Util::decimalToFloat($rowPIS["VRIMPOSTOIT"]);
                }
            } else {
                $vBC = "0.00";
                $pPIS = "0.00";
                $vPIS = "0.00";
            }
            $PISAliq = $this->DOM->createElement("PISAliq");
            $CST = $this->DOM->createElement("CST", $CST);
            $PISAliq->appendChild($CST);
            $vBC = $this->DOM->createElement("vBC", $vBC);
            $PISAliq->appendChild($vBC);
            $pPIS = $this->DOM->createElement("pPIS", $pPIS);
            $PISAliq->appendChild($pPIS);
            $vPIS = $this->DOM->createElement("vPIS", $vPIS);
            $PISAliq->appendChild($vPIS);
            $PIS->appendChild($PISAliq);
        } elseif ($rowPIS["CST"] === "03") {
            //PISQtde [Q03]
            $CST = $rowPIS["CST"];
            $qBCProd = $rowPIS["QTITEMPROD"];
            if ($rowPIS["CDFISCALIT"] === "1") {
                $vAliqProd = number_format(Util::decimalToFloat($rowPIS["VALORIMPOSTOALIQ"]), 4, ".", "");
                $vPIS = number_format(Util::decimalToFloat($rowPIS["VALORIMPOSTO"]), 2, ".", "");
                //PIS ISSQN
                if ($ISSQN) {
                    $this->valorTotalPISISSQN += Util::decimalToFloat($rowPIS["VRIMPOSTOIT"]);
                } else {
                    $this->valorTotalPIS += Util::decimalToFloat($rowPIS["VRIMPOSTOIT"]);
                }
            } else {
                $vAliqProd = "0.0000";
                $vPIS = "0.00";
            }

            $PISQtde = $this->DOM->createElement("PISQtde");
            $CST = $this->DOM->createElement("CST", $CST);
            $PISQtde->appendChild($CST);
            $qBCProd = $this->DOM->createElement("qBCProd", $qBCProd);
            $PISQtde->appendChild($qBCProd);
            $vAliqProd = $this->DOM->createElement("vAliqProd", $vAliqProd);
            $PISQtde->appendChild($vAliqProd);
            $vPIS = $this->DOM->createElement("vPIS", $vPIS);
            $PISQtde->appendChild($vPIS);
            $PIS->appendChild($PISQtde);
        } elseif (in_array($rowPIS["CST"], array("04", "06", "07", "08", "09"))) {
            //PISNT [Q04]
            //Grupo de PIS não tributado 0 ou 1 [PIS]
            $CST = $rowPIS["CST"];
            $PISNT = $this->DOM->createElement("PISNT");
            $CST = $this->DOM->createElement("CST", $CST);
            $PISNT->appendChild($CST);
            $PIS->appendChild($PISNT);
        } elseif (in_array($rowPIS["CST"], array("05", "49", "50", "51", "52", "53", "54", "55", "56", "60", "61", "62", "63",
                "64", "65", "66", "67", "70", "71", "72", "73", "74", "75", "98", "99"))
        ) {
            //PISOutr [Q05]
            $CST = $rowPIS["CST"];
            //                    $qBCProd = $rowPIS["QTITEMPROD"];

            if ($rowPIS["CDFISCALIT"] === "1") {
                //                        $vAliqProd = number_format(Util::decimalToFloat($rowPIS["VALORIMPOSTOALIQ"]), 4);
                //Valor da Base de Cálculo do PIS e Alíquota do PIS (em percentual) 0 pu 1 [PISOutr]
                $vBC = number_format(Util::decimalToFloat($rowPIS["BASECALCULO"]), 2, ".", "");
                $pPIS = number_format(Util::decimalToFloat($rowPIS["ALIQUOTA"]), 2, ".", "");
                //Grupo de PIS Outras Operações 0 ou 1 [PIS]
                $vPIS = number_format(Util::decimalToFloat($rowPIS["VALORIMPOSTO"]), 2, ".", "");
                //PIS ISSQN
                if ($ISSQN) {
                    $this->valorTotalPISISSQN += Util::decimalToFloat($rowPIS["VRIMPOSTOIT"]);
                } else {
                    $this->valorTotalPIS += Util::decimalToFloat($rowPIS["VRIMPOSTOIT"]);
                }
            } else {
                //                        $vAliqProd = "0.0000";
                //Valor da Base de Cálculo do PIS e Alíquota do PIS (em percentual) 0 pu 1 [PISOutr]
                $vBC = "0.00";
                $pPIS = "0.00";
                //Grupo de PIS Outras Operações 0 ou 1 [PIS]
                $vPIS = "0.00";
                //Quantidade Vendida e Alíquota do PIS (em reais) 0 ou 1 [PISOutr]
                //                    $this->txtStructure[] = "Q10|$qBCProd|$vAliqProd|";
            }

            $PISOutr = $this->DOM->createElement("PISOutr");
            $CST = $this->DOM->createElement("CST",$CST);
            $PISOutr->appendChild($CST);
            $vPIS = $this->DOM->createElement("vPIS", $vPIS);
            $PISOutr->appendChild($vPIS);
            $PIS->appendChild($PISOutr);
            $vBC = $this->DOM->createElement("vBC", $vBC);
            $PISOutr->insertBefore($vBC,$vPIS);
            $pPIS = $this->DOM->createElement("pPIS", $pPIS);
            $PISOutr->insertBefore($pPIS,$vPIS);

            if (!empty($rowPIS["CDIMPOSTRIB"])) {
                $dstImpostrib = $dstImpostos->find(array("CDIMPOSTRIB" => $rowPIS["CDIMPOSTRIB"]));
                if ($dstImpostrib) {
                    //PISST [R]
                    $rowImpostrib = $dstImpostrib->first();
                    //                            $qBCProd = $rowImpostrib["QTITEMPROD"];
                    //                            $vAliqProd = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTOALIQ"]), 4);

                    //Grupo de PIS Substituição Tributária 0 ou 1 [imposto]
                    $vPIS = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $PISST = $this->DOM->createElement("PISST");
                    $vPIS = $this->DOM->createElement("vPIS", $vPIS);
                    $PISST->appendChild($vPIS);
                    $this->tags["imposto"]->appendChild($PISST);

                    //Valor da Base de Cálculo do PIS e Alíquota do PIS (em percentual) 0 ou 1 [PISST]
                    $vBC = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
                    $pPIS = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                    $vBC = $this->DOM->createElement("vBC", $vBC);
                    $PISST->appendChild($vBC);
                    $pPIS = $this->DOM->createElement("pPIS", $pPIS);
                    $PISST->appendChild($pPIS);
                    //Quantidade Vendida e Alíquota do PIS (em reais) 0 ou 1 [PISST]
                    //                            $this->txtStructure[] = "R04|$qBCProd|$vAliqProd";
                }
            }
        }
    }

    /**
     * Grupo do Imposto de Importação 0 ou 1 [imposto] [P]
     * @param $rowII
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagII($rowII, \Geral\Util\Dataset $dstImpostos)
    {
        $vII = "";
        $vIOF = "";
        $vBC = $rowII["BASECALCULO"];
        if (!empty($rowII["VRDESPADUANEIRA"])) {
            $vDespAdu = number_format(Util::decimalToFloat($rowII["DESPESASADUANEIRAS"]), 2, ".", "");
        } else {
            $vDespAdu = "0.00";
        }
        if ($rowII["CDFISCALIT"] === "1") {
            $vII = number_format(Util::decimalToFloat($rowII["VALORIMPOSTO"]), 2, ".", "");
            $this->valorTotalVII += Util::decimalToFloat($rowII["VRIMPOSTOIT"]);
        }
        //IOF
        $IOF = $dstImpostos->find(array("CDIMPOSTRIB" => "40"));
        if ($IOF) {
            $rowIOF = $IOF->first();
            if ($rowIOF["CDFISCALIT"] === "1") {
                $vIOF = number_format(Util::decimalToFloat($rowIOF["VALORIMPOSTO"]), 2, ".", "");
            }
        } else {
            $vIOF = "0.00";
        }

        $II = $this->DOM->createElement("II");
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $II->appendChild($vBC);
        $vDespAdu = $this->DOM->createElement("vDespAdu", $vDespAdu);
        $II->appendChild($vDespAdu);
        $vII = $this->DOM->createElement("vII", $vII);
        $II->appendChild($vII);
        $vIOF = $this->DOM->createElement("vIOF", $vIOF);
        $II->appendChild($vIOF);
        $this->tags["imposto"]->appendChild($II);
    }

    /**
     * Grupo do IPI 0 ou 1 [imposto] [O]
     * @param $rowIPI
     */
    private function criaTagIPI($rowIPI)
    {
        $clEnq = "";
        $CNPJProd = "";
        $cSelo = "";
        $qSelo = "";
        $cEnq = "999";

        $this->tags["IPI"] = $this->DOM->createElement("IPI");
        if(!empty($clEnq)) {
            $clEnq = $this->DOM->createElement("clEnq", $clEnq);
            $this->tags["IPI"]->appendChild($clEnq);
        }
        if(!empty($CNPJProd)) {
            $CNPJProd = $this->DOM->createElement("CNPJProd", $CNPJProd);
            $this->tags["IPI"]->appendChild($CNPJProd);
        }
        if(!empty($cSelo)) {
            $cSelo = $this->DOM->createElement("cSelo", $cSelo);
            $this->tags["IPI"]->appendChild($cSelo);
        }
        if(!empty($qSelo)) {
            $qSelo = $this->DOM->createElement("qSelo", $qSelo);
            $this->tags["IPI"]->appendChild($qSelo);
        }
        if(!empty($cEnq)) {
            $cEnq = $this->DOM->createElement("cEnq", $cEnq);
            $this->tags["IPI"]->appendChild($cEnq);
        }
        $this->tags["imposto"]->appendChild($this->tags["IPI"]);

        if (in_array($rowIPI["CST"], array("00", "49", "50", "99"))) {
            //Grupo do IPITrib CST 00, 49, 50 e 99 0 ou 1 [IPI]
            $CST = $rowIPI["CST"];
            if ($rowIPI["CDFISCALIT"] === "1") {
                //BC e Percentagem de IPI 0 ou 1 [IPITrib]
                $vBC = $rowIPI["BASECALCULO"];
                $pIPI = number_format(Util::decimalToFloat($rowIPI["ALIQUOTA"]), 2, ".", "");
                //Grupo do IPITrib CST 00, 49, 50 e 99 0 ou 1 [IPI]
                $vIPI = number_format(Util::decimalToFloat($rowIPI["VALORIMPOSTO"]), 2, ".", "");
                $this->valorTotalIPI += Util::decimalToFloat($rowIPI["VRIMPOSTOIT"]);
            } else {
                //BC e Percentagem de IPI 0 ou 1 [IPITrib]
                $vBC = "0.00";
                $pIPI = "0.00";
                $vIPI = "0.00";
            }

            $this->txtStructure[] = "O07|$CST|$vIPI";
            $this->txtStructure[] = "O10|$vBC|$pIPI";

            $IPITrib = $this->DOM->createElement("IPITrib");
            $CST = $this->DOM->createElement("CST", $CST);
            $IPITrib->appendChild($CST);
            $vIPI = $this->DOM->createElement("vIPI", $vIPI);
            $IPITrib->appendChild($vIPI);
            $this->tags["IPI"]->appendChild($IPITrib);
            $vBC = $this->DOM->createElement("vBC", $vBC);
            $IPITrib->insertBefore($IPITrib->appendChild($vBC), $vIPI);
            $pIPI = $this->DOM->createElement("pIPI", $pIPI);
            $IPITrib->insertBefore($IPITrib->appendChild($pIPI), $vIPI);
        } elseif (in_array($rowIPI["CST"], array("01", "02", "03", "04", "05", "51", "52", "53", "54", "55"))) {
            //IPINT
            //Grupo IPI Não tributavel 0 ou 1 [IPI]
            $CST = $rowIPI["CST"];

            $this->txtStructure[] = "O08|$CST";

            $IPINT = $this->DOM->createElement("IPINT");
            $CST = $this->DOM->createElement("CST", $CST);
            $IPINT->appendChild($CST);
            $this->tags["IPI"]->appendChild($IPINT);
        }
    }

    private function criaTagISSQN($rowItemProd, $rowISSQN)
    {
        $cSitTrib = "";
        $this->valorTotalVSERV += Util::decimalToFloat($rowItemProd["VRTOTAITEMFLOAT"]);
        $vBC = $rowISSQN["BASECALCULO"];
        $this->valorTotalVBCISSQN += Util::decimalToFloat($rowISSQN["VRBASECALCIT"]);
        $vAliq = number_format(Util::decimalToFloat($rowISSQN["ALIQUOTA"]), 2, ".", "");
        $vISSQN = number_format(Util::decimalToFloat($rowISSQN["VALORIMPOSTO"]), 2, ".", "");
        $this->valorTotalVISS += Util::decimalToFloat($rowISSQN["VRIMPOSTOIT"]);
        $cMunFG = $this->corpoNF["CDMUNIIBGEEMIT"];
        //Verifica o codigo para classificação do serviço
        $dstClassServico = $this->repository->get("nfeTransClassificaServico" . $rowItemProd["CDARVPROD"]);
        if (!$dstClassServico) {
            $dstClassServico = new Dataset(Produto::getRepository()->consultaClassificacaoServico($rowItemProd["CDARVPROD"]));
            DatasetRepository::getInstance()->add("nfeTransClassificaServico" . $rowItemProd["CDARVPROD"], $dstClassServico);
        }
        $rowClassServico = $dstClassServico->first();
        $cListServ = $rowClassServico["CDCLASSPROD"];
        if (!empty($rowISSQN["CDTRIBISSQN"])) {
            $cSitTrib = $rowISSQN["CDTRIBISSQN"];
        }

        $this->tags["ISSQN"] = $this->DOM->createElement("ISSQN");
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $this->tags["ISSQN"]->appendChild($vBC);
        $vAliq = $this->DOM->createElement("vAliq", $vAliq);
        $this->tags["ISSQN"]->appendChild($vAliq);
        $vISSQN = $this->DOM->createElement("vISSQN", $vISSQN);
        $this->tags["ISSQN"]->appendChild($vISSQN);
        $cMunFG = $this->DOM->createElement("cMunFG", $cMunFG);
        $this->tags["ISSQN"]->appendChild($cMunFG);
        $cListServ = $this->DOM->createElement("cListServ",$cListServ);
        $this->tags["ISSQN"]->appendChild($cListServ);
        $cSitTrib = $this->DOM->createElement("cSitTrib",$cSitTrib);
        $this->tags["ISSQN"]->appendChild($cSitTrib);
        $this->tags["imposto"]->appendChild($this->tags["ISSQN"]);
    }

    /**
     * Imposto [ICMS]
     * @param $rowItemProd
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     * @return void
     */
    private function criaTagICMS($rowItemProd, $rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $this->txtStructure[] = "N";
        $this->tags["ICMS"] = $this->DOM->createElement("ICMS");
        $this->tags["imposto"]->appendChild($this->tags["ICMS"]);

        if (Parametros::getSituacaoCRT() === "1") {
            if ($rowItemProd["CDFISCOPERSN"] === "101") {
                //Imposto.ICMS.ICMSSN10
                $this->criaTagICMSSN101($rowICMS);
            } elseif ($rowItemProd["CDFISCOPERSN"] === "201") {
                //Imposto.ICMS.ICMSSN201
                $this->criaTagICMSSN201($rowICMS, $dstImpostos);
            } elseif ($rowItemProd["CDFISCOPERSN"] === "500") {
                //Imposto.ICMS.ICMSSN500
                $this->criaTagICMSSN500($rowICMS, $dstImpostos);
            } elseif ($rowItemProd["CDFISCOPERSN"] === "900") {
                //Imposto.ICMS.ICMSSN900
                $this->criaTagICMSSN900($rowICMS, $dstImpostos);
            } elseif (in_array($rowItemProd["CDFISCOPERSN"], array("202", "203"))) {
                //Imposto.ICMS.ICMSSN202
                $this->criaTagICMSSN202($rowICMS, $dstImpostos);
            } elseif (in_array($rowItemProd["CDFISCOPERSN"], array("102", "103", "300", "400"))) {
                //Imposto.ICMS.ICMSSN102
                $this->criaTagICMSSN102($rowICMS, $rowItemProd);
            }
        } else {
            if ($rowICMS["CST"] === "00") {
                //Imposto.ICMS.ICMS00
                $this->criaTagICMS00($rowICMS);
            } elseif ($rowICMS["CST"] === "10") {
                //Imposto.ICMS.ICMS10
                $this->criaTagICMS10($rowICMS, $dstImpostos);
            } elseif ($rowICMS["CST"] === "20") {
                //Imposto.ICMS.ICMS20
                $this->criaTagICMS20($rowICMS);
            } elseif ($rowICMS["CST"] === "30") {
                //Imposto.ICMS.ICMS30
                $this->criaTagICMS30($rowICMS, $dstImpostos);
            } elseif (in_array($rowICMS["CST"], array("40", "41", "50"))) {
                //Imposto.ICMS.ICMS40
                $this->criaTagICMS40($rowICMS);
            } elseif ($rowICMS["CST"] === "51") {
                //Imposto.ICMS.ICMS51
                $this->criaTagICMS51($rowICMS);
            } elseif ($rowICMS["CST"] === "60") {
                //Imposto.ICMS.ICMS60
                $this->criaTagICMS60($rowICMS, $dstImpostos);
            } elseif ($rowICMS["CST"] === "70") {
                //Imposto.ICMS.ICMS70
                $this->criaTagICMS70($rowICMS, $dstImpostos);
            } elseif ($rowICMS["CST"] === "90") {
                //Imposto.ICMS.ICMS90
                $this->criaTagICMS90($rowICMS, $dstImpostos);
            }
        }
    }

    /**
     * Grupo de Tributação do ICMS 90 Outros [ICMS] [N10]
     * @param $rowICMS
     * @param $dstImpostos
     * @return array
     */
    private function criaTagICMS90($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pRedBC = "";
        $pRedBCST = "";
        $pMVAST = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBC = $rowICMS["IDMODBCITNFE"];
        if ($rowICMS["CDFISCALIT"] === "1") {
            $vBC = number_format(Util::decimalToFloat($rowICMS["BASECALCULO"]), 2, ".", "");
            $pICMS = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
            $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
            $this->valorTotalBC += Util::decimalToFloat($rowICMS["VRBASECALCIT"]);
            $this->valorTotalICMS += Util::decimalToFloat($rowICMS["VRIMPOSTOIT"]);
        } else {
            $vBC = "0.00";
            $pICMS = "0.00";
            $vICMS = "0.00";
        }

        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $this->valorTotalICMSDeson += $rowICMS['VRIMPOSTOIT'];
            $motDesICMS = $rowICMS['IDMOTDESONERAIT'];
        }

        $modBCST = $rowICMS["IDMODBCSTITNFE"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST = $rowImpostrib["PERCENTUALRED"];
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST = "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                } else {
                    $pICMSST = "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST = "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }
        } else {
            $vBCST = '0.00';
            $pICMSST = '0.00';
            $vICMSST = '0.00';
        }

        $ICMS90 = $this->DOM->createElement("ICMS90");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS90->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS90->appendChild($CST);
        $modBC = $this->DOM->createElement("modBC", $modBC);
        $ICMS90->appendChild($modBC);
        if(!empty($pRedBC)) {
            $pRedBC = $this->DOM->createElement("pRedBC", $pRedBC);
            $ICMS90->appendChild($pRedBC);
        }
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $ICMS90->appendChild($vBC);
        $pICMS = $this->DOM->createElement("pICMS", $pICMS);
        $ICMS90->appendChild($pICMS);
        $vICMS = $this->DOM->createElement("vICMS", $vICMS);
        $ICMS90->appendChild($vICMS);
        $modBCST = $this->DOM->createElement("modBCST", $modBCST);
        $ICMS90->appendChild($modBCST);
        if(!empty($pMVAST)) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMS90->appendChild($pMVAST);
        }
        if(!empty($pRedBCST)) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMS90->appendChild($pRedBCST);
        }
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMS90->appendChild($vBCST);
        $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
        $ICMS90->appendChild($pICMSST);
        $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
        $ICMS90->appendChild($vICMSST);
        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $vICMSDeson = $this->DOM->createElement("vICMSDeson", $vICMS);
            $ICMS90->appendChild($vICMSDeson);
            $motDesICMS = $this->DOM->createElement("motDesICMS", $motDesICMS);
            $ICMS90->appendChild($motDesICMS);
        }
        $this->tags["ICMS"]->appendChild($ICMS90);
    }

    /**
     * Grupo de Tributação do ICMS = 70 [ICMS] [N09]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMS70($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pRedBCST = "";
        $pMVAST = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBC = $rowICMS["IDMODBCITNFE"];
        $pRedBC = $rowICMS["PERCENTUALRED"];
        if ($rowICMS["CDFISCALIT"] === "1") {
            $vBC = number_format(Util::decimalToFloat($rowICMS["BASECALCULO"]), 2, ".", "");
            $pICMS = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
            $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
            $this->valorTotalBC += Util::decimalToFloat($rowICMS["VRBASECALCIT"]);
            $this->valorTotalICMS += Util::decimalToFloat($rowICMS["VRIMPOSTOIT"]);
        } else {
            $vBC = "0.00";
            $pICMS = "0.00";
            $vICMS = "0.00";
        }

        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $this->valorTotalICMSDeson += $rowICMS['VRIMPOSTOIT'];
            $motDesICMS = $rowICMS['IDMOTDESONERAIT'];
        }

        $modBCST = $rowICMS["IDMODBCSTITNFE"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST = $rowImpostrib["PERCENTUALRED"];
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST = "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                } else {
                    $pICMSST = "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST = "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }
        } else {
            $vBCST = '0.00';
            $pICMSST = '0.00';
            $vICMSST = '0.00';
        }

        $ICMS70 = $this->DOM->createElement("ICMS70");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS70->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS70->appendChild($CST);
        $modBC = $this->DOM->createElement("modBC", $modBC);
        $ICMS70->appendChild($modBC);
        $pRedBC = $this->DOM->createElement("pRedBC", $pRedBC);
        $ICMS70->appendChild($pRedBC);
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $ICMS70->appendChild($vBC);
        $pICMS = $this->DOM->createElement("pICMS", $pICMS);
        $ICMS70->appendChild($pICMS);
        $vICMS = $this->DOM->createElement("vICMS", $vICMS);
        $ICMS70->appendChild($vICMS);
        $modBCST = $this->DOM->createElement("modBCST", $modBCST);
        $ICMS70->appendChild($modBCST);
        if(!empty($pMVAST)) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMS70->appendChild($pMVAST);
        }
        if(!empty($pRedBCST)) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMS70->appendChild($pRedBCST);
        }
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMS70->appendChild($vBCST);
        $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
        $ICMS70->appendChild($pICMSST);
        $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
        $ICMS70->appendChild($vICMSST);
        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $vICMSDeson = $this->DOM->createElement("vICMSDeson", $vICMS);
            $ICMS70->appendChild($vICMSDeson);
            $motDesICMS = $this->DOM->createElement("motDesICMS", $motDesICMS);
            $ICMS70->appendChild($motDesICMS);
        }
        $this->tags["ICMS"]->appendChild($ICMS70);
    }

    /**
     * Grupo de Tributação do ICMS = 60 [ICMS] [N08]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMS60($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $vBCSTRet = "";
        $vICMSSTRet = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            $rowImpostrib = $dstImpostrib->first();
            if (!empty($rowImpostrib["BASECALCULO"])) {
                $vBCSTRet = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
            }
            if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                $vICMSSTRet = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
            } else {
                $vBCSTRet = '0.00';
                $vICMSSTRet = '0.00';
            }
        }

        $ICMS60 = $this->DOM->createElement("ICMS60");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS60->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS60->appendChild($CST);
        $vBCSTRet = $this->DOM->createElement("vBCSTRet", $vBCSTRet);
        $ICMS60->appendChild($vBCSTRet);
        $vICMSSTRet = $this->DOM->createElement("vICMSSTRet", $vICMSSTRet);
        $ICMS60->appendChild($vICMSSTRet);
        $this->tags["ICMS"]->appendChild($ICMS60);
    }

    /**
     * Grupo de Tributação do ICMS = 51 [ICMS]
     * @param $rowICMS
     */
    private function criaTagICMS51($rowICMS)
    {
        $pRedBC = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBC = $rowICMS["IDMODBCITNFE"];
        if ($rowICMS["CDFISCALIT"] === "1") {
            $vBC = number_format(Util::decimalToFloat($rowICMS["BASECALCULO"]), 2, ".", "");
            $pICMS = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
            $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
        } else {
            $vBC = '0.00';
            $pICMS = '0.00';
            $vICMS = '0.00';
        }

        $ICMS51 = $this->DOM->createElement("ICMS51");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS51->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS51->appendChild($CST);
        if(!empty($modBC)) {
            $modBC = $this->DOM->createElement("modBC", $modBC);
            $ICMS51->appendChild($modBC);
        }
        if(!empty($pRedBC)) {
            $pRedBC = $this->DOM->createElement("pRedBC", $pRedBC);
            $ICMS51->appendChild($pRedBC);
        }
        if(!empty($vBC)) {
            $vBC = $this->DOM->createElement("vBC", $vBC);
            $ICMS51->appendChild($vBC);
        }
        if(!empty($pICMS)) {
            $pICMS = $this->DOM->createElement("pICMS", $pICMS);
            $ICMS51->appendChild($pICMS);
        }
        if(!empty($vICMS)) {
            $vICMS = $this->DOM->createElement("vICMS", $vICMS);
            $ICMS51->appendChild($vICMS);
        }
        $this->tags["ICMS"]->appendChild($ICMS51);
    }

    /**
     * Grupo de Tributação do ICMS 40, 41 ou 50 [ICMS] [N06]
     * @param $rowICMS
     */
    private function criaTagICMS40($rowICMS)
    {
        $motDesICMS = "";
        $vICMS = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        if ($rowICMS["IDIMPDESONERAIT"] === "S") {
            $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
            $this->valorTotalICMSDeson += $rowICMS['VRIMPOSTOIT'];
            $motDesICMS = $rowICMS["IDMOTDESONERAIT"];
        }

        $ICMS40 = $this->DOM->createElement("ICMS40");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS40->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS40->appendChild($CST);
        if(!empty($vICMS)) {
            $vICMS = $this->DOM->createElement("vICMS", $vICMS);
            $ICMS40->appendChild($vICMS);
        }
        if($rowICMS["IDIMPDESONERAIT"] === "S") {
            $vICMSDeson = $this->DOM->createElement("vICMSDeson", $vICMS);
            $ICMS40->appendChild($vICMSDeson);
            $motDesICMS = $this->DOM->createElement("motDesICMS", $motDesICMS);
            $ICMS40->appendChild($motDesICMS);
        }
        $this->tags["ICMS"]->appendChild($ICMS40);
    }

    /**
     * CST 030 ISENTA OU NAO TRIBUTADO E COM COBRANCA DO ICMS POR ST [ICMS] [N05]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMS30($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pRedBCST = "";
        $pMVAST = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBCST = $rowICMS["IDMODBCSTITNFE"];

        $vICMS = $rowICMS['VALORIMPOSTO'];
        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $this->valorTotalICMSDeson += $rowICMS['VRIMPOSTOIT'];
            $motDesICMS = $rowICMS['IDMOTDESONERAIT'];
        }

        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST = $rowImpostrib["PERCENTUALRED"];
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST = "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                } else {
                    $pICMSST = "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST = "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }
        } else {
            $vBCST = '0.00';
            $pICMSST = '0.00';
            $vICMSST = '0.00';
        }

        $ICMS30 = $this->DOM->createElement("ICMS30");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS30->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS30->appendChild($CST);
        $modBCST = $this->DOM->createElement("modBCST", $modBCST);
        $ICMS30->appendChild($modBCST);
        if(!empty($pMVAST)) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMS30->appendChild($pMVAST);
        }
        if(!empty($pRedBCST)) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMS30->appendChild($pRedBCST);
        }
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMS30->appendChild($vBCST);
        $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
        $ICMS30->appendChild($pICMSST);
        $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
        $ICMS30->appendChild($vICMSST);
        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $vICMSDeson = $this->DOM->createElement("vICMSDeson", $vICMS);
            $ICMS30->appendChild($vICMSDeson);
            $motDesICMS = $this->DOM->createElement("motDesICMS", $motDesICMS);
            $ICMS30->appendChild($motDesICMS);
        }
        $this->tags["ICMS"]->appendChild($ICMS30);
    }

    /**
     * CST 020 COM REDUCAO DE BASE DE CALCULO [ICMS] [N04]
     * @param $rowICMS
     */
    private function criaTagICMS20($rowICMS)
    {
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBC = $rowICMS["IDMODBCITNFE"];
        if (Util::decimalToFloat($rowICMS["VRPERREDBCIT"]) > 0) {
            $pRedBC = number_format(Util::decimalToFloat($rowICMS["PERCENTUALRED"]), 2, ".", "");
        } else {
            $pRedBC = "0.00";
        }
        if ($rowICMS["CDFISCALIT"] === "1") {
            $vBC = $rowICMS["BASECALCULO"];
            $pICMS = $rowICMS["ALIQUOTA"];
            $vICMS = $rowICMS["VALORIMPOSTO"];
            $this->valorTotalBC += Util::decimalToFloat($rowICMS["VRBASECALCIT"]);
            $this->valorTotalICMS += Util::decimalToFloat($rowICMS["VRIMPOSTOIT"]);
        } else {
            $vBC = '0.00';
            $pICMS = '0.00';
            $vICMS = '0.00';
        }

        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $this->valorTotalICMSDeson += $rowICMS['VRIMPOSTOIT'];
            $motDesICMS = $rowICMS['IDMOTDESONERAIT'];
        }

        $ICMS20 = $this->DOM->createElement("ICMS20");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS20->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS20->appendChild($CST);
        $modBC = $this->DOM->createElement("modBC", $modBC);
        $ICMS20->appendChild($modBC);
        $pRedBC = $this->DOM->createElement("pRedBC", $pRedBC);
        $ICMS20->appendChild($pRedBC);
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $ICMS20->appendChild($vBC);
        $pICMS = $this->DOM->createElement("pICMS", $pICMS);
        $ICMS20->appendChild($pICMS);
        $vICMS = $this->DOM->createElement("vICMS", $vICMS);
        $ICMS20->appendChild($vICMS);
        if($rowICMS['IDIMPDESONERAIT'] == 'S'){
            $vICMSDeson = $this->DOM->createElement("vICMSDeson", $vICMS);
            $ICMS20->appendChild($vICMSDeson);
            $motDesICMS = $this->DOM->createElement("motDesICMS", $motDesICMS);
            $ICMS20->appendChild($motDesICMS);
        }
        $this->tags["ICMS"]->appendChild($ICMS20);
    }

    /**
     * CST 010 TRIBUTADO E COM COBRANCAO DE ICMS POR SUBSTUICAO TRIBUTARIA [ICMS] [N03]
     * @param $rowICMS
     * @param $dstImpostos
     * @return array
     */
    private function criaTagICMS10($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pRedBCST = "";
        $pMVAST = "";
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBC = $rowICMS["IDMODBCITNFE"];
        if ($rowICMS["CDFISCALIT"] === "1") {
            $vBC = number_format(Util::decimalToFloat($rowICMS["BASECALCULO"]), 2, ".", "");
            $pICMS = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
            $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
            $this->valorTotalBC += Util::decimalToFloat($rowICMS["VRBASECALCIT"]);
            $this->valorTotalICMS += Util::decimalToFloat($rowICMS["VRIMPOSTOIT"]);
        } else {
            $vBC = "0.00";
            $pICMS = "0.00";
            $vICMS = "0.00";
        }
        $modBCST = $rowICMS["IDMODBCSTITNFE"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST = $rowImpostrib["PERCENTUALRED"];
                } else {
                    $pMVAST = $rowImpostrib["PERCENTUALRED"];
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST = number_format(Util::decimalToFloat($rowImpostrib["BASECALCULO"]), 2, ".", "");
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST = "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                } else {
                    $pICMSST = "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST = "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }

        } else {
            $vBCST = '0.00';
            $pICMSST = '0.00';
            $vICMSST = '0.00';
        }

        $ICMS10 = $this->DOM->createElement("ICMS10");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS10->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS10->appendChild($CST);
        $modBC = $this->DOM->createElement("modBC", $modBC);
        $ICMS10->appendChild($modBC);
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $ICMS10->appendChild($vBC);
        $pICMS = $this->DOM->createElement("pICMS", $pICMS);
        $ICMS10->appendChild($pICMS);
        $vICMS = $this->DOM->createElement("vICMS", $vICMS);
        $ICMS10->appendChild($vICMS);
        $modBCST = $this->DOM->createElement("modBCST", $modBCST);
        $ICMS10->appendChild($modBCST);
        if(!empty($pMVAST)) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMS10->appendChild($pMVAST);
        }
        if(!empty($pRedBCST)) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMS10->appendChild($pRedBCST);
        }
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMS10->appendChild($vBCST);
        $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
        $ICMS10->appendChild($pICMSST);
        $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
        $ICMS10->appendChild($vICMSST);
        $this->tags["ICMS"]->appendChild($ICMS10);

    }

    /**
     * CST 00 TRIBUTADO INTEGRALMENTE [ICMS] [N02]
     * @param $rowICMS
     * @return array
     */
    private function criaTagICMS00($rowICMS)
    {
        $orig = $rowICMS["ORIGEM"];
        $CST = $rowICMS["CST"];
        $modBC = $rowICMS["IDMODBCITNFE"];
        if ($rowICMS["CDFISCALIT"] === "1") {
            $vBC = number_format(Util::decimalToFloat($rowICMS["BASECALCULO"]), 2, ".", "");
            $pICMS = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
            $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
            $this->valorTotalBC += $rowICMS["VRBASECALCIT"];
            $this->valorTotalICMS += $rowICMS["VRIMPOSTOIT"];
        } else {
            $vBC = "0.00";
            $pICMS = "0.00";
            $vICMS = "0.00";
        }

        $ICMS00 = $this->DOM->createElement("ICMS00");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMS00->appendChild($orig);
        $CST = $this->DOM->createElement("CST", $CST);
        $ICMS00->appendChild($CST);
        $modBC = $this->DOM->createElement("modBC", $modBC);
        $ICMS00->appendChild($modBC);
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $ICMS00->appendChild($vBC);
        $pICMS = $this->DOM->createElement("pICMS", $pICMS);
        $ICMS00->appendChild($pICMS);
        $vICMS = $this->DOM->createElement("vICMS", $vICMS);
        $ICMS00->appendChild($vICMS);
        $this->tags["ICMS"]->appendChild($ICMS00);
    }

    /**
     * Grupo CRT=1 Simples Nacional e CSOSN=102, 103,300 ou 400 [ICMS] [N10d]
     * @param $rowICMS
     * @param $rowItemProd
     */
    private function criaTagICMSSN102($rowICMS, $rowItemProd)
    {
        $orig = $rowICMS["ORIGEMSN"];
        $CSOSN = $rowItemProd["CDFISCOPERSN"];

        $ICMSSN102 = $this->DOM->createElement("ICMSSN102");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMSSN102->appendChild($orig);
        $CSOSN = $this->DOM->createElement("CSOSN", $CSOSN);
        $ICMSSN102->appendChild($CSOSN);
        $this->tags["ICMS"]->appendChild($ICMSSN102);
    }

    /**
     * Grupo CRT=1  Simples Nacional e CSOSN=202 ou 203 [ICMS]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMSSN202($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pRedBCST = "";
        $pMVAST = "";
        $vBCST = "";
        $pICMSST = "";
        $vICMSST = "";
        $orig = $rowICMS["ORIGEMSN"];
        $CSOSN = $rowICMS["CDFISCOPERSN"];
        $modBCST = $rowICMS["IDMODBCSTITNFE"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST = number_format(Util::decimalToFloat($rowImpostrib["PERCENTUALRED"]), 2, ".", "");
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST = $rowImpostrib["BASECALCULO"];
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST = "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"], 2), ".", "");
                } else {
                    $pICMSST = "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST = "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }
        }

        $ICMSSN202 = $this->DOM->createElement("ICMSSN202");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMSSN202->appendChild($orig);
        $CSOSN = $this->DOM->createElement("CSOSN", $CSOSN);
        $ICMSSN202->appendChild($CSOSN);
        $modBCST = $this->DOM->createElement("modBCST", $modBCST);
        $ICMSSN202->appendChild($modBCST);
        if(!empty($pMVAST)) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMSSN202->appendChild($pMVAST);
        }
        if(!empty($pRedBCST)) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMSSN202->appendChild($pRedBCST);
        }
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMSSN202->appendChild($vBCST);
        $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
        $ICMSSN202->appendChild($pICMSST);
        $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
        $ICMSSN202->appendChild($vICMSST);
        $this->tags["ICMS"]->appendChild($ICMSSN202);
    }

    /**
     * Grupo CRT=1 Simples Nacional e CSOSN=900 [ICMS][N10h]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMSSN900($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pMVAST = "";
        $pRedBCST = "";
        $pRedBC = "";
        $orig = $rowICMS["ORIGEMSN"];
        $CSOSN = '900';
        $modBC = $rowICMS["IDMODBCITNFE"];
        if ($rowICMS["CDFISCALIT"] === "1") {
            if (!empty($rowICMS["BASECALCULO"])) {
                $vBC = number_format(Util::decimalToFloat($rowICMS["BASECALCULO"]), 2, ".", "");
            } else {
                $vBC = "0.00";
            }
            if (Util::decimalToFloat($rowICMS["VRPERREDBCIT"]) > 0) {
                $pRedBC = number_format(Util::decimalToFloat($rowICMS["PERCENTUALRED"]), 2, ".", "");
            }
            if (!empty($rowICMS["ALIQUOTA"])) {
                $pICMS = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
            } else {
                $pICMS = "0.00";
            }
            if (!empty($rowICMS["VALORIMPOSTO"])) {
                $vICMS = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
            } else {
                $vICMS = "0.00";
            }
            $this->valorTotalBC += Util::decimalToFloat($rowICMS["VRBASECALCIT"]);
            $this->valorTotalICMS += Util::decimalToFloat($rowICMS["VRIMPOSTOIT"]);
        } else {
            $vBC = '0.00';
            $pICMS = '0.00';
            $vICMS = '0.00';
        }
        $modBCST = $rowICMS["IDMODBCSTITNFE"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST = $rowImpostrib["PERCENTUALRED"];
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST = $rowImpostrib["BASECALCULO"];
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST = "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST = number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                } else {
                    $pICMSST = "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST = number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST = "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }
        } else {
            $vBCST = '0.00';
            $pICMSST = '0.00';
            $vICMSST = '0.00';
        }
        if (!empty($rowICMS["BASECALCULORETIDO"])) {
            $vBCSTRet = number_format(Util::decimalToFloat($rowICMS["BASECALCULORETIDO"]), 2, ".", "");
        } else {
            $vBCSTRet = "0.00";
        }
        if (!empty($rowICMS["VALORIMPOSTORETIDO"])) {
            $vICMSSTRet = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTORETIDO"]), 2, ".", "");
        } else {
            $vICMSSTRet = "0.00";
        }
        if (!empty($rowICMS["ALIQUOTA"])) {
            $pCredSN = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
        } else {
            $pCredSN = "0.00";
        }
        if (!empty($rowICMS["VALORIMPOSTO"])) {
            $vCredICMSSN = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
        } else {
            $vCredICMSSN = "0.00";
        }

        $ICMSSN900 = $this->DOM->createElement("ICMSSN900");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMSSN900->appendChild($orig);
        $CSOSN = $this->DOM->createElement("CSOSN", $CSOSN);
        $ICMSSN900->appendChild($CSOSN);
        if(!empty($modBC)){
            $modBC = $this->DOM->createElement("modBC", $modBC);
            $ICMSSN900->appendChild($modBC);
        }
        if(!empty($vBC)){
            $vBC = $this->DOM->createElement("vBC", $vBC);
            $ICMSSN900->appendChild($vBC);
        }
        if(!empty($pRedBC)) {
            $pRedBC = $this->DOM->createElement("pRedBC", $pRedBC);
            $ICMSSN900->appendChild($pRedBC);
        }
        if(!empty($pICMS)){
            $pICMS = $this->DOM->createElement("pICMS", $pICMS);
            $ICMSSN900->appendChild($pICMS);
        }
        if(!empty($vICMS)){
            $vICMS = $this->DOM->createElement("vICMS", $vICMS);
            $ICMSSN900->appendChild($vICMS);
        }
        if(!empty($modBCST)){
            $modBCST = $this->DOM->createElement("modBCST", $modBCST);
            $ICMSSN900->appendChild($modBCST);
        }
        if(!empty($pMVAST)) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMSSN900->appendChild($pMVAST);
        }
        if(!empty($pRedBCST)) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMSSN900->appendChild($pRedBCST);
        }
        if(!empty($vBCST)){
            $vBCST = $this->DOM->createElement("vBCST", $vBCST);
            $ICMSSN900->appendChild($vBCST);
        }
        if(!empty($pICMSST)){
            $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
            $ICMSSN900->appendChild($pICMSST);
        }
        if(!empty($vICMSST)){
            $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
            $ICMSSN900->appendChild($vICMSST);
        }
        if(!empty($pCredSN)){
            $pCredSN = $this->DOM->createElement("pCredSN", $pCredSN);
            $ICMSSN900->appendChild($pCredSN);
        }
        if(!empty($vCredICMSSN)){
            $vCredICMSSN = $this->DOM->createElement("vCredICMSSN", $vCredICMSSN);
            $ICMSSN900->appendChild($vCredICMSSN);
        }
        $this->tags["ICMS"]->appendChild($ICMSSN900);
    }

    /**
     * Grupo CRT=1 Simples Nacional e CSOSN = 500 [ICMS]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMSSN500($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $orig= $rowICMS["ORIGEMSN"];
        $CSOSN= "500";
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            $rowImpostrib = $dstImpostrib->first();
            if (!empty($rowImpostrib["BASECALCULORETIDO"])) {
                $vBCSTRet= number_format(Util::decimalToFloat($rowImpostrib["BASECALCULORETIDO"]), 2, ".", "");
            } else {
                $vBCSTRet= "0.00";
            }
            if (!empty($rowImpostrib["VALORIMPOSTORETIDO"])) {
                $vICMSSTRet= number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTORETIDO"]), 2, ".", "");
            } else {
                $vICMSSTRet= "0.00";
            }
        } else {
            $vBCSTRet= '0.00';
            $vICMSSTRet= '0.00';
        }

        $ICMSSN500 = $this->DOM->createElement("ICMSSN500");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMSSN500->appendChild($orig);
        $CSOSN = $this->DOM->createElement("CSOSN", $CSOSN);
        $ICMSSN500->appendChild($CSOSN);
        $vBCSTRet = $this->DOM->createElement("vBCSTRet", $vBCSTRet);
        $ICMSSN500->appendChild($vBCSTRet);
        $vICMSSTRet = $this->DOM->createElement("vICMSSTRet", $vICMSSTRet);
        $ICMSSN500->appendChild($vICMSSTRet);
        $this->tags["ICMS"]->appendChild($ICMSSN500);
    }

    /**
     * Grupo CRT=1  Simples Nacional e CSOSN=201 [ICMS]
     * @param $rowICMS
     * @param \Geral\Util\Dataset $dstImpostos
     */
    private function criaTagICMSSN201($rowICMS, \Geral\Util\Dataset $dstImpostos)
    {
        $pRedBCST= "";
        $pMVAST= "";
        $orig= $rowICMS["ORIGEMSN"];
        $CSOSN= '201';
        $modBCST= $rowICMS["IDMODBCSTITNFE"];
        if (!empty($rowICMS["CDIMPOSTRIB"])) {
            $dstImpostrib = $dstImpostos->find(array("CDIMPOSTO" => $rowICMS["CDIMPOSTRIB"]));
            if($dstImpostrib){
                $rowImpostrib = $dstImpostrib->first();
                if (Util::decimalToFloat($rowImpostrib["VRPERREDBCIT"]) > 0) {
                    $pMVAST= number_format(Util::decimalToFloat($rowImpostrib["PERCENTUALRED"]), 2, ".", "");
                }
                if (!empty($rowImpostrib["BASECALCULO"])) {
                    $vBCST= $rowImpostrib["BASECALCULO"];
                    $this->valorTotalBCST += Util::decimalToFloat($rowImpostrib["VRBASECALCIT"]);
                } else {
                    $vBCST= "0.00";
                }
                if (!empty($rowImpostrib["ALIQUOTA"])) {
                    $pICMSST= number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
                } else {
                    $pICMSST= "0.00";
                }
                if (!empty($rowImpostrib["VALORIMPOSTO"])) {
                    $vICMSST= number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
                    $this->valorTotalICMSST += Util::decimalToFloat($rowImpostrib["VRIMPOSTOIT"]);
                } else {
                    $vICMSST= "0.00";
                }
            }
            else{
                $vBCST = '0.00';
                $pICMSST = '0.00';
                $vICMSST = '0.00';
            }
        } else {
            $vBCST= '0.00';
            $pICMSST= '0.00';
            $vICMSST= '0.00';
        }
        if (!empty($rowImpostrib["ALIQUOTA"])) {
            $pCredSN= number_format(Util::decimalToFloat($rowImpostrib["ALIQUOTA"]), 2, ".", "");
        } else {
            $pCredSN= "0.00";
        }
        if (!empty($rowImpostrib["VALORIMPOSTO"])) {
            $vCredICMSSN= number_format(Util::decimalToFloat($rowImpostrib["VALORIMPOSTO"]), 2, ".", "");
        } else {
            $vCredICMSSN= "0.00";
        }

        $ICMSSN201 = $this->DOM->createElement("ICMSSN201");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMSSN201->appendChild($orig);
        $CSOSN = $this->DOM->createElement("CSOSN", $CSOSN);
        $ICMSSN201->appendChild($CSOSN);
        $modBCST = $this->DOM->createElement("modBCST", $modBCST);
        $ICMSSN201->appendChild($modBCST);
        if(!empty($dados[4])) {
            $pMVAST = $this->DOM->createElement("pMVAST", $pMVAST);
            $ICMSSN201->appendChild($pMVAST);
        }
        if(!empty($dados[5])) {
            $pRedBCST = $this->DOM->createElement("pRedBCST", $pRedBCST);
            $ICMSSN201->appendChild($pRedBCST);
        }
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMSSN201->appendChild($vBCST);
        $pICMSST = $this->DOM->createElement("pICMSST", $pICMSST);
        $ICMSSN201->appendChild($pICMSST);
        $vICMSST = $this->DOM->createElement("vICMSST", $vICMSST);
        $ICMSSN201->appendChild($vICMSST);
        $pCredSN = $this->DOM->createElement("pCredSN", $pCredSN);
        $ICMSSN201->appendChild($pCredSN);
        $vCredICMSSN = $this->DOM->createElement("vCredICMSSN", $vCredICMSSN);
        $ICMSSN201->appendChild($vCredICMSSN);
        $this->tags["ICMS"]->appendChild($ICMSSN201);
    }

    /**
     * Grupo CRT=1  Simples Nacional e CSOSN=101 [ICMS]
     * @param $rowICMS
     */
    private function criaTagICMSSN101($rowICMS)
    {
        //Imposto.ICMS.ICMSSN101
        $orig = $rowICMS["ORIGEMSN"];
        $CSOSN = "101";
        if (!empty($rowICMS["ALIQUOTA"])) {
            $pCredSN = number_format(Util::decimalToFloat($rowICMS["ALIQUOTA"]), 2, ".", "");
        } else {
            $pCredSN = "0.00";
        }
        if (!empty($rowICMS["VALORIMPOSTO"])) {
            $vCredICMSSN = number_format(Util::decimalToFloat($rowICMS["VALORIMPOSTO"]), 2, ".", "");
        } else {
            $vCredICMSSN = "0.00";
        }

        $ICMSSN101 = $this->DOM->createElement("ICMSSN101");
        $orig = $this->DOM->createElement("orig", $orig);
        $ICMSSN101->appendChild($orig);
        $CSOSN = $this->DOM->createElement("CSOSN", $CSOSN);
        $ICMSSN101->appendChild($CSOSN);
        $pCredSN = $this->DOM->createElement("pCredSN", $pCredSN);
        $ICMSSN101->appendChild($pCredSN);
        $vCredICMSSN = $this->DOM->createElement("vCredICMSSN", $vCredICMSSN);
        $ICMSSN101->appendChild($vCredICMSSN);
        $this->tags["ICMS"]->appendChild($ICMSSN101);
    }

    /**
     * Grupo do detalhamento de Medicamentos e de matériasprimas farmacêuticas [prod]
     * @param $rowItemProd
     */
    private function criaTagDetalheMedicamentoEMateriasPrimasFarmaceuticas($rowItemProd)
    {
        $nLote = "";
        if (!empty($rowItemProd["NRLOTEESTQ"])) {
            $nLote = trim($rowItemProd["NRLOTEESTQ"]);
        }

        $qLote = "";
        // De acordo com o LabGlobo passar a quantidade da nota
        if (!empty($rowItemProd["QTPRODLOTE"])) {
            $qLote = $rowItemProd["QTPRODLOTE"];
        }

        $dVal = "";
        $dFab  = $rowItemProd["DTFABRPROD"];
        if (!empty($rowItemProd["DTVALILOTE"])) {
            $dVal = $rowItemProd["DTVALILOTE"];
        }

        if ($this->corpoNF["IDORIGDESTNF"] === "C") {
            $paramCliente = $this->corpoNF["CDCLIENTE"];
        } elseif ($this->corpoNF["IDORIGDESTNF"] === "F") {
            $paramCliente = $this->corpoNF["CDFORNECED"];
        } elseif ($this->corpoNF["IDORIGDESTNF"] === "S") {
            $paramCliente = $this->corpoNF["CDFILIRECE"];
        } else {
            $paramCliente = $this->corpoNF["CDFILIEMIT"];
        }

        $resultSetInscricaoSuframa = new Dataset(Notafiscal::getRepository()->consultaInscricaoSuframaNFE($paramCliente));
        $row = $resultSetInscricaoSuframa->first();
        if (!empty($row["NRSUFRAMA"])) {
            $resultSetVrMaxSuframa = new Dataset(Vrmaxvenprod::getRepository()->consultaMaxValorSuframa($this->corpoNF["CDPAISCLIE"], "SF"));
            $rowMaxSuframa = $resultSetVrMaxSuframa->first();
            if (!empty($rowMaxSuframa["VRMAXVENDA"])) {
                $vPMC = number_format(Util::decimalToFloat($rowMaxSuframa["VRMAXVENDA"]), 2, ".", "");
            } else {
                $vPMC = "0.00";
            }
        } else {
            if (!empty($rowItemProd["VRMAXVENDA"])) {
                $vPMC = number_format(Util::decimalToFloat($rowItemProd["VRMAXVENDA"]), 2, ".", "");
            } else {
                $vPMC = "0.00";
            }
        }

        $med = $this->DOM->createElement("med");
        if(!empty($nLote)) {
            $nLote = $this->DOM->createElement("nLote", $nLote);
            $med->appendChild($nLote);
        }
        if(!empty($qLote)) {
            $qLote = $this->DOM->createElement("qLote",$qLote);
            $med->appendChild($qLote);
        }
        if(!empty($dFab)) {
            $dFab = $this->DOM->createElement("dFab", $dFab);
            $med->appendChild($dFab);
        }
        $dVal = $this->DOM->createElement("dVal", $dVal);
        $med->appendChild($dVal);
        if(!empty($vPMC)) {
            $vPMC = $this->DOM->createElement("vPMC", $vPMC);
            $med->appendChild($vPMC);
        }
        $this->tags["prod"]->appendChild($med);
    }

    /**
     * PRODUTO SERVICO [det]
     * @param $rowItemProd
     * @return mixed
     */
    private function criaTagProdutoServico($rowItemProd)
    {
        $cProd = trim($rowItemProd["CDARVPROD"]);
        $cEAN = trim($rowItemProd["CDBARPRODUTO"]);
        $xProd = trim(str_replace(chr(13), " ", str_replace(chr(10), " ", Util::removeAcentos($rowItemProd["DSPRODEMIS"]))));
        $EXTIPI = "";
        $NCM = "";
        if (!empty($rowItemProd["NCM"]) && strlen(trim(Util::removeMascaraInscricao($rowItemProd["NCM"]))) >= 2) {
            $NCM = trim(Util::removeMascaraInscricao($rowItemProd["NCM"]));
            $objItemproduto = Itemproduto::getObjectByWhere("CDFILIAL = ? AND NRLANCTONF = ? AND NRSEQITPROD = ?", array($rowItemProd["CDFILIAL"], $rowItemProd["NRLANCTONF"], $rowItemProd["NRSEQITPROD"]));
            $objItemproduto->setCdprodncmtrans($NCM);
        }

        $CFOP = $rowItemProd["CFOP"];
        $uCom = trim($rowItemProd["SGUNIDADE"]);
        $qCom = trim($rowItemProd["QTITEMPROD"]);
        $vUnCom = $rowItemProd["VRUNITITEM"];
        $vProd = $rowItemProd["VRTOTAITEM"];
        $cEANTrib = trim($rowItemProd["CDBARPRODUTO"]);
        $uTrib = $rowItemProd["SGUNIDADE"];
        $qTrib = $rowItemProd["QTITEMPROD"];
        $vUnTrib = $rowItemProd["VRUNITITEM"];
        $vFrete = "";
        $vSeg = "";
        $vDesc = "";
        $vOutro = "";

        $dstDesonera = new Dataset(Itemproimpos::getRepository()->consultaDesoneraItem($rowItemProd["CDFILIAL"], $rowItemProd["NRLANCTONF"], $rowItemProd["NRSEQITPROD"]));
        $rowDesonera = $dstDesonera->first();

        if (Util::decimalToFloat($rowItemProd["VRFRETEITEM"]) > 0)
            $vFrete = number_format(Util::decimalToFloat($rowItemProd["VRFRETE"]), 2, ".", "");
        if (Util::decimalToFloat($rowItemProd["VRSEGURITEM"]) > 0)
            $vSeg = number_format(Util::decimalToFloat($rowItemProd["VRSEGURO"]), 2, ".", "");
        if (Util::decimalToFloat($rowItemProd["VRENCARGODESC"]) > 0 || Util::decimalToFloat($rowDesonera["VRIMPOSTOIT"]) > 0)
            $vDesc = number_format((Util::decimalToFloat($rowItemProd["VRENCARGODESC"]) + Util::decimalToFloat($rowDesonera["VRIMPOSTOIT"])), 2, ".", "");
        if (Util::decimalToFloat($rowItemProd["VROUTRASDESPITEM"]) > 0)
            $vOutro = $rowItemProd["OUTRASDESPESAS"];

        $xPed = "";
        $nrpedprod = Util::removeCharsFromString(Util::removeAcentos($rowItemProd["NRPEDPROD"]));
        if (!empty($nrpedprod)) {
            $xPed = $nrpedprod;
        }

        $nrseqpedprod = Util::removeCharsFromString(Util::removeAcentos($rowItemProd["NRSEQPEDPROD"]));
        $nItemPed = "";
        if (!empty($nrseqpedprod)) {
            $nItemPed = $nrseqpedprod;
        }
        //0 = Valor do item não compõe o valor total da NF
        //1 = Valor do item compõe o valor total da NF
        //No sistema teknisa, todos os produtos compõe o valor tota da nota fiscal
        $indTot = "1";
        $this->tags["prod"] = $this->DOM->createElement("prod");
        $cProd = $this->DOM->createElement("cProd", $cProd);
        $this->tags["prod"]->appendChild($cProd);
        $cEAN = $this->DOM->createElement("cEAN", $cEAN);
        $this->tags["prod"]->appendChild($cEAN);
        $xProd = $this->DOM->createElement("xProd", $xProd);
        $this->tags["prod"]->appendChild($xProd);
        $NCM = $this->DOM->createElement("NCM", $NCM);
        $this->tags["prod"]->appendChild($NCM);
        if(!empty($EXTIPI)) {
            $EXTIPI = $this->DOM->createElement("EXTIPI", $EXTIPI);
            $this->tags["prod"]->appendChild($EXTIPI);
        }
        $CFOP = $this->DOM->createElement("CFOP", $CFOP);
        $this->tags["prod"]->appendChild($CFOP);
        $uCom = $this->DOM->createElement("uCom", $uCom);
        $this->tags["prod"]->appendChild($uCom);
        $qCom = $this->DOM->createElement("qCom", $qCom);
        $this->tags["prod"]->appendChild($qCom);
        $vUnCom = $this->DOM->createElement("vUnCom", $vUnCom);
        $this->tags["prod"]->appendChild($vUnCom);
        $vProd = $this->DOM->createElement("vProd", $vProd);
        $this->tags["prod"]->appendChild($vProd);
        $cEANTrib = $this->DOM->createElement("cEANTrib", $cEANTrib);
        $this->tags["prod"]->appendChild($cEANTrib);
        if(!empty($uTrib)) {
            $uTrib = $this->DOM->createElement("uTrib", $uTrib);
        } else {
            $uTrib = $this->DOM->createElement("uTrib", $uCom);
        }
        $this->tags["prod"]->appendChild($uTrib);
        if(!empty($qTrib)) {
            $qTrib = $this->DOM->createElement("qTrib", $qTrib);
        } else {
            $qTrib = $this->DOM->createElement("qTrib", $qCom);
        }
        $this->tags["prod"]->appendChild($qTrib);
        if(!empty($vUnTrib)) {
            $vUnTrib = $this->DOM->createElement("vUnTrib", $vUnTrib);
        } else {
            $vUnTrib = $this->DOM->createElement("vUnTrib", $vUnCom);
        }
        $this->tags["prod"]->appendChild($vUnTrib);
        if(!empty($vFrete)) {
            $vFrete = $this->DOM->createElement("vFrete", $vFrete);
            $this->tags["prod"]->appendChild($vFrete);
        }
        if(!empty($vSeg)) {
            $vSeg = $this->DOM->createElement("vSeg", $vSeg);
            $this->tags["prod"]->appendChild($vSeg);
        }
        if(!empty($vDesc)) {
            $vDesc = $this->DOM->createElement("vDesc", $vDesc);
            $this->tags["prod"]->appendChild($vDesc);
        }
        if(!empty($vOutro)) {
            $vOutro = $this->DOM->createElement("vOutro", $vOutro);
            $this->tags["prod"]->appendChild($vOutro);
        }
        if(!empty($indTot) || $indTot == 0) {
            $indTot = $this->DOM->createElement("indTot", $indTot);
            $this->tags["prod"]->appendChild($indTot);
        } else {
            $indTot = $this->DOM->createElement("indTot", '0');
            $this->tags["prod"]->appendChild($indTot);
        }
        if(!empty($xPed)) {
            $xPed = $this->DOM->createElement("xPed", $xPed);
            $this->tags["prod"]->appendChild($xPed);
        }
        if(!empty($nItemPed)) {
            $nItemPed = $this->DOM->createElement("nItemPed", $nItemPed);
            $this->tags["prod"]->appendChild($nItemPed);
        }
        if (!isset($infAdProd)){
            $this->tags["det"]->appendChild($this->tags["prod"]);
        } else {
            $this->tags["det"]->insertBefore($this->tags["det"]->appendChild($this->tags["prod"]),$infAdProd);
        }

        if (!empty($rowItemProd["CFOP"])) {
            if (strlen($rowItemProd["CFOP"]) === 4) {
                if ($rowItemProd["CFOP"][0] === "3") {
                    $params = array(
                        "CDFILIAL" => $rowItemProd["CDFILIAL"],
                        "NRLANCTONF" => $rowItemProd["NRLANCTONF"],
                        "NRSEQITPROD" => $rowItemProd["NRSEQITPROD"]
                    );
                    $objDecimpnfe = Decimpnfe::getObjectByWhere("CDFILIAL = :CDFILIAL AND NRLANCTONF = :NRLANCTONF AND ((NRSEQITPROD = :NRSEQITPROD) OR (:NRSEQITPROD = 'T'))", $params);
                    if ($objDecimpnfe instanceof \Indeterminado\Entities\Decimpnfe) {
                        //@TODO ADICIONAR AO ARRAY FINAL
                        $this->criaTagDeclaraImporta($objDecimpnfe);
                        //@TODO ADICIONAR AO ARRAY FINAL
                        $this->criaTagAdicoes($params);
                    }
                }
            }
        }
    }

    /*
     * Tag da Declaração de Importação [prod]
     */
    private function criaTagDeclaraImporta(\Indeterminado\Entities\Decimpnfe $objDecimpnfe)
    {

        $nDI = $objDecimpnfe->getNrdocimpnfe();
        $dDI  = $objDecimpnfe->getDtregimpnfe()->format("Y-m-d");
        $xLocDesemb = $objDecimpnfe->getDslocembimp();
        $UFDesemb = $objDecimpnfe->getSguflocembimp();
        $dDesemb = $objDecimpnfe->getDtdesembimp();
        $cExportador = $objDecimpnfe->getCdexpimpnfe();
        $this->tags["DI"] = $this->DOM->createElement("DI");
        if(!empty($nDI)) {
            $nDI = $this->DOM->createElement("nDI", $nDI);
            $this->tags["DI"]->appendChild($nDI);
        }
        if(!empty($dDI)) {
            $dDI = $this->DOM->createElement("dDI", $dDI);
            $this->tags["DI"]->appendChild($dDI);
        }
        if(!empty($xLocDesemb)) {
            $xLocDesemb = $this->DOM->createElement("xLocDesemb", $xLocDesemb);
            $this->tags["DI"]->appendChild($xLocDesemb);
        }
        if(!empty($UFDesemb)) {
            $UFDesemb = $this->DOM->createElement("UFDesemb", $UFDesemb);
            $this->tags["DI"]->appendChild($UFDesemb);
        }
        if(!empty($dDesemb)) {
            $dDesemb = $this->DOM->createElement("dDesemb", $dDesemb);
            $this->tags["DI"]->appendChild($dDesemb);
        }
        if(!empty($cExportador)) {
            $cExportador = $this->DOM->createElement("cExportador", $cExportador);
            $this->tags["DI"]->appendChild($cExportador);
        }
        if (!isset($xPed)){
            $this->tags["prod"]->appendChild($this->tags["DI"]);
        } else {
            $this->tags["prod"]->insertBefore($this->tags["prod"]->appendChild($this->tags["DI"]),$xPed);
        }
    }

    /**
     * Adições [DI][I25]
     * @param $params
     */
    private function criaTagAdicoes($params)
    {
        $arObjAdicionais = Adicdecimpnfe::getObjectsByWhere("CDFILIAL = :CDFILIAL AND NRLANCTONF = :NRLANCTONF AND ((NRSEQITPROD = :NRSEQITPROD) OR (:NRSEQITPROD = 'T'))", $params, "NRSEQADICDEC");
        if (!empty($arObjAdicionais)) {
            /**@var $objAdicional \Indeterminado\Entities\Adicdecimpnfe */
            foreach ($arObjAdicionais as $objAdicional) {
                $nAdicao = $objAdicional->getNradicdecimp();
                $nSeqAdic = $objAdicional->getNrseqadicdec();
                if ($objAdicional->getCdfabricadic() !== "") {
                    $cFabricante = $objAdicional->getCdfabricadic();
                }
                $vDescDI = "";
                $adi = $this->DOM->createElement("adi");
                if(!empty($nAdicao)) {
                    $nAdicao = $this->DOM->createElement("nAdicao", $nAdicao);
                    $adi->appendChild($nAdicao);
                }
                if(!empty($nSeqAdic)) {
                    $nSeqAdic = $this->DOM->createElement("nSeqAdic", $nSeqAdic);
                    $adi->appendChild($nSeqAdic);
                }
                if(!empty($cFabricante)) {
                    $cFabricante = $this->DOM->createElement("cFabricante", $cFabricante);
                    $adi->appendChild($cFabricante);
                }
                if(!empty($vDescDI)) {
                    $vDescDI = $this->DOM->createElement("vDescDI", $vDescDI);
                    $adi->appendChild($vDescDI);
                }
                $this->tags["DI"]->appendChild($adi);
            }
        }
    }

    /**
     * Grupo de Valores Totais da NF-e obrigatorio [infNFe]
     * @param $rowItemProd
     */
    private function criaTagDadosTotais()
    {
        $this->tags["total"] = $this->DOM->createElement("total");
        $this->tags["infNFe"]->appendChild($this->tags["total"]);

        $this->criaTagDadosTotaisICMS();
        if (isset($this->tags["ISSQN"])) {
            $this->criaTagDadosTotaisISSQN();
        }
    }

    /**
     * Grupo de Valores Totais referentes ao ISSQN 0 ou 1 [total]
     */
    private function criaTagDadosTotaisISSQN()
    {
        if ($this->valorTotalVSERV > 0) {
            $vServ = number_format($this->valorTotalVSERV, 2, ".", "");
            $vBC = "";
            if ($this->valorTotalVBCISSQN > 0)
                $vBC = number_format($this->valorTotalVBCISSQN, 2, ".", "");
            $vISS = "";
            if ($this->valorTotalVISS > 0)
                $vISS = number_format($this->valorTotalVISS, 2, ".", "");
            $vPIS = "";
            if ($this->valorTotalPISISSQN > 0)
                $vPIS = number_format($this->valorTotalPISISSQN, 2, ".", "");
            $vCOFINS = "";
            if ($this->valorTotalCOFINSISSQN > 0)
                $vCOFINS = number_format($this->valorTotalCOFINSISSQN, 2, ".", "");
        }

        $ISSQNtot = $this->DOM->createElement("ISSQNtot");
        if(!empty($vServ)) {
            $vServ = $this->DOM->createElement("vServ", $vServ);
            $ISSQNtot->appendChild($vServ);
        }
        if(!empty($vBC)) {
            $vBC = $this->DOM->createElement("vBC", $vBC);
            $ISSQNtot->appendChild($vBC);
        }
        if(!empty($vISS)) {
            $vISS = $this->DOM->createElement("vISS", $vISS);
            $ISSQNtot->appendChild($vISS);
        }
        if(!empty($vPIS)) {
            $vPIS = $this->DOM->createElement("vPIS", $vPIS);
            $ISSQNtot->appendChild($vPIS);
        }
        if(!empty($vCOFINS)) {
            $vCOFINS = $this->DOM->createElement("vCOFINS", $vCOFINS);
            $ISSQNtot->appendChild($vCOFINS);
        }
        $this->tags["total"]->appendChild($ISSQNtot);
    }

    /**
     * Grupo de Valores Totais referentes ao ICMS obrigatorio [total]
     * @param $rowItemProd
     */
    private function criaTagDadosTotaisICMS()
    {
        $vBC = number_format($this->valorTotalBC, 2, ".", "");
        $vICMS = number_format($this->valorTotalICMS, 2, ".", "");
        $vICMSDeson = number_format($this->valorTotalICMSDeson, 2, ".", "");
        $vBCST = number_format($this->valorTotalBCST, 2, ".", "");
        $vST = number_format($this->valorTotalICMSST, 2, ".", "");

        //Valor tota do itens sem desconto
        $vProd = number_format($this->valorTotalVPROD, 2, ".", "");

        // Inicia dataset dos encargos para funcoes de soma de valor encargo
        $dstEncargo = new Dataset(Encargo::getRepository()->consultaEncargosNotaFiscal($this->corpoNF["NRLANCTONF"], $this->corpoNF["CDFILIAL"]));
        DatasetRepository::getInstance()->add("nfeTransEncargo", $dstEncargo);

        $somaDescontoItem = Util::decimalToFloat(Itemproduto::getRepository()->getSomaDescontoItem($this->corpoNF["NRLANCTONF"], $this->corpoNF["CDFILIAL"]));
        // ENCARGO [01]
        $vFrete = number_format($this->somaValorEncargo("01"), 2, ".", "");
        // ENCARGO [02]
        $vSeg = number_format($this->somaValorEncargo("02"), 2, ".", "");
        // ENCARGO [03]
        $dstDesonera = new Dataset(Itemproimpos::getRepository()->consultaDesoneraItem($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"], "T"));
        $rowDesonera = $dstDesonera->first();
        //Valor tota do itens sem desconto
        $dstTotalItensNF = new Dataset(Itemproduto::getRepository()->somaTotalItensNF($this->corpoNF["NRLANCTONF"], $this->corpoNF["CDFILIAL"]));

        if ($vFrete > 0 || $somaDescontoItem > 0 || !$dstTotalItensNF->isEmpty() || Util::decimalToFloat($rowDesonera["VRIMPOSTOIT"]) > 0) {
            $vDesc = number_format($this->somaValorEncargo("03") + $somaDescontoItem + Util::decimalToFloat($rowDesonera["VRIMPOSTOIT"]), 2, ".", "");
        } else {
            $vDesc = "0.00";
        }

        $vII = number_format($this->valorTotalVII, 2, ".", "");
        $vIPI = number_format($this->valorTotalIPI, 2, ".", "");
        $vPIS = number_format($this->valorTotalPIS, 2, ".", "");
        $vCOFINS = number_format($this->valorTotalCOFINS, 2, ".", "");

        // ENCARGO [04]
        $vOutro = number_format($this->somaValorEncargo("04"), 2, ".", "");
        // TOTAL DA NOTA FISCAL
        $vNF = number_format(Util::decimalToFloat($this->corpoNF["VRNOTAFISC"]), 2, ".", "");
        // TAG XML OBRIGATORIA
        $ICMSTot = $this->DOM->createElement("ICMSTot");
        $vBC = $this->DOM->createElement("vBC", $vBC);
        $ICMSTot->appendChild($vBC);
        $vICMS = $this->DOM->createElement("vICMS", $vICMS);
        $ICMSTot->appendChild($vICMS);
        $vICMSDeson = $this->DOM->createElement("vICMSDeson", $vICMSDeson);
        $ICMSTot->appendChild($vICMSDeson);
        $vBCST = $this->DOM->createElement("vBCST", $vBCST);
        $ICMSTot->appendChild($vBCST);
        $vST = $this->DOM->createElement("vST", $vST);
        $ICMSTot->appendChild($vST);
        $vProd = $this->DOM->createElement("vProd", $vProd);
        $ICMSTot->appendChild($vProd);
        $vFrete = $this->DOM->createElement("vFrete", $vFrete);
        $ICMSTot->appendChild($vFrete);
        $vSeg = $this->DOM->createElement("vSeg", $vSeg);
        $ICMSTot->appendChild($vSeg);
        $vDesc = $this->DOM->createElement("vDesc", $vDesc);
        $ICMSTot->appendChild($vDesc);
        $vII = $this->DOM->createElement("vII", $vII);
        $ICMSTot->appendChild($vII);
        $vIPI = $this->DOM->createElement("vIPI", $vIPI);
        $ICMSTot->appendChild($vIPI);
        $vPIS = $this->DOM->createElement("vPIS", $vPIS);
        $ICMSTot->appendChild($vPIS);
        $vCOFINS = $this->DOM->createElement("vCOFINS", $vCOFINS);
        $ICMSTot->appendChild($vCOFINS);
        $vOutro = $this->DOM->createElement("vOutro", $vOutro);
        $ICMSTot->appendChild($vOutro);
        $vNF = $this->DOM->createElement("vNF", $vNF);
        $ICMSTot->appendChild($vNF);
        $this->tags["total"]->appendChild($ICMSTot);
    }

    /**
     * Grupo de Cobrança 0 ou 1 [infNFe] [Y]
     */
    private function criaTagCobranca()
    {
        //        $dados[] = "Y";

        $dstContarec = new Dataset(Contareceber::getRepository()->consultaContarecerNFE($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"]));
        if (!$dstContarec->isEmpty()) {
            $itContarec = $dstContarec->getIterator();
            while ($itContarec->valid()) {
                $rowContarec = $itContarec->current();
                $this->criaTagDuplicata($rowContarec);
                $itContarec->next();
            }

            //            $dados[] = "Y07|$nDup|$dVenc|$vDup|";
        }
    }

    /**
     * Grupo da Duplicata 0 a N [cobr] [Y07]
     * @param $rowContarec
     */
    private function criaTagDuplicata($rowContarec)
    {
        $nDup = $this->getNumeroNotaFiscal() . "/" . $rowContarec["NRSEQVENREC"];
        if (!empty($rowContarec["DTORIGVENREC"])) {
            $dVenc = \DateTime::createFromFormat('d/m/Y H:i:s', $rowContarec["DTORIGVENREC"], new \DateTimeZone('America/Sao_Paulo'))->format("Y-m-d");
        }
        $vDup = $rowContarec["VRORIGREC"];
        if (!isset($this->tags["cobr"])){
            $this->tags["cobr"] = $this->DOM->createElement("cobr");
            $this->tags["infNFe"]->appendChild($this->tags["cobr"]);
        }
        $dup = $this->DOM->createElement("dup");
        if(!empty($nDup)) {
            $nDup = $this->DOM->createElement("nDup", $nDup);
            $dup->appendChild($nDup);
        }
        if(!empty($dVenc)) {
            $dVenc = $this->DOM->createElement("dVenc", $dVenc);
            $dup->appendChild($dVenc);
        }
        if(!empty($vDup)) {
            $vDup = $this->DOM->createElement("vDup", $vDup);
            $dup->appendChild($vDup);
        }
        $this->tags["cobr"]->appendChild($dup);
    }

    /**
     * Grupo de Informações Adicionais 0 ou 1 [infNFe] [Z]
     */
    private function criaTagInformacoesAdicionais()
    {
        $infAdFisco  = "";
        if (isset($this->info))
            $infAdFisco = trim(str_replace(chr(13), "", str_replace(chr(10), "", substr($this->info, 0, 2000))));

        //Rotina especifica do LabGlobo.
        $dstLista = new Dataset(Itemproduto::getRepository()->consultaListaNFE($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"]));

        if (!$dstLista->isEmpty()) {
            $infCompl = "";
            $itLista = $dstLista->getIterator();
            while ($itLista->valid()) {
                $rowLista = $itLista->current();

                $infCompl = trim($infCompl . " " . Util::removeAcentos($rowLista["DSLISTA"]));

                $itLista->next();
            }
        }

        $infCpl=  "";
        if (isset($infCompl)){
            $infCpl = trim(str_replace(chr(13), "", str_replace(chr(10), "", substr($infCompl, 0, 5000))));

            $this->txtStructure[] = "Z|$infAdFisco|$infCpl|";

            $this->tags["infAdic"] = $this->DOM->createElement("infAdic");
            if(!empty($infAdFisco)) {
                $infAdFisco = $this->DOM->createElement("infAdFisco", $infAdFisco);
                $this->tags["infAdic"]->appendChild($infAdFisco);
            }
            if(!empty($infCpl)) {
                $infCpl = $this->DOM->createElement("infCpl", $infCpl);
                $this->tags["infAdic"]->appendChild($infCpl);
            }
            $this->tags["infNFe"]->appendChild($this->tags["infAdic"]);

            // ESSA ROTINA DE FISCO DEVE SER ADAPTADA PARA ACEITAR MAIS DE UMA OCORRÊNCIA. POIS O PRÓPRIO MANUAL PERMITE ATÉ 10 OCORRÊNCIAS
            $objDadosfisco = \Indeterminado\Entities\Dadosfisco::getObjectByWhere("CDFILIAL = ? AND NRLANCTONF = ? AND TO_NUMBER(NRDADOFISCO) <= 10", array($this->corpoNF["CDFILIAL"], $this->corpoNF["NRLANCTONF"]));
            if ($objDadosfisco instanceof \Indeterminado\Entities\Dadosfisco) {
                $this->criaTagFisco($objDadosfisco);
            }

            // Informacoes de comercio exterior
            if ($this->corpoNF["IDENTRSAIDOP"] === "S") {
                if ($this->corpoNF["CDPAISBACENCLIE"] !== "1058") {
                    $this->criaTagExportacao();
                }
            }
        }
    }

    /**
     * Grupo de Exportação 0 ou 1 [infNFe] [ZA]
     */
    private function criaTagExportacao()
    {
        $UFEmbarq = trim($this->corpoNF["SGESTAEMIT"]);
        $xLocEmbarq = trim($this->replaceCharsForParser(Util::removeAcentos($this->corpoNF["NMMUNIEMIT"])));

        $exporta = $this->DOM->createElement("exporta");
        $UFEmbarq = $this->DOM->createElement("UFEmbarq", $UFEmbarq);
        $exporta->appendChild($UFEmbarq);
        $xLocEmbarq = $this->DOM->createElement("xLocEmbarq", $xLocEmbarq);
        $exporta->appendChild($xLocEmbarq);
        $this->tags["infNFe"]->appendChild($exporta);

        $this->txtStructure[] = "ZA|$UFEmbarq|$xLocEmbarq|";
    }

    /**
     * Grupo do campo de uso livre do Fisco 0-10 [infAdic] [Z07]
     * @param $objDadosfisco
     */
    private function criaTagFisco(\Indeterminado\Entities\Dadosfisco $objDadosfisco)
    {
        $xCampo = $objDadosfisco->getCddadofisco();
        $xTexto = $objDadosfisco->getDsdadofisco();

        $obsFisco = $this->DOM->createElement("obsFisco");
        $obsFisco->setAttribute("xCampo", $xCampo);
        $xTexto = $this->DOM->createElement("xTexto", $xTexto);
        $obsFisco->appendChild($xTexto);
        $this->tags["infAdic"]->appendChild($obsFisco);

        $this->txtStructure[] = "Z07|$xCampo|$xTexto|";
    }

    /**
     *__calculaDV
     * Função para o calculo o digito verificador da chave da NFe
     * @param string $chave43
     * @return string
     */
    private function __calculaDV($chave43) {
        $multiplicadores = array(2,3,4,5,6,7,8,9);
        $i = 42;
        $soma_ponderada=0;
        while ($i >= 0) {
            for ($m=0; $m<count($multiplicadores) && $i>=0; $m++) {
                $soma_ponderada+= $chave43[$i] * $multiplicadores[$m];
                $i--;
            }
        }
        $resto = $soma_ponderada % 11;
        if ($resto == '0' || $resto == '1') {
            $cDV = 0;
        } else {
            $cDV = 11 - $resto;
        }
        return $cDV;
    } //fim __calculaDV

    /**
     * __calculaChave
     *
     */
    private function __montaChaveXML(){
        $ide    =  $this->DOM->getElementsByTagName("ide")->item(0);
        $this->tags["emit"]   =  $this->DOM->getElementsByTagName("emit")->item(0);
        $cUF    = $ide->getElementsByTagName('cUF')->item(0)->nodeValue;
        $dhEmi   = $ide->getElementsByTagName('dhEmi')->item(0)->nodeValue;
        $CNPJ   = $this->tags["emit"]->getElementsByTagName('CNPJ')->item(0)->nodeValue;
        $mod    = $ide->getElementsByTagName('mod')->item(0)->nodeValue;
        $serie  = $ide->getElementsByTagName('serie')->item(0)->nodeValue;
        $nNF    = $ide->getElementsByTagName('nNF')->item(0)->nodeValue;
        $tpEmis = $ide->getElementsByTagName('tpEmis')->item(0)->nodeValue;
        $cNF    = $ide->getElementsByTagName('cNF')->item(0)->nodeValue;
        if( strlen($cNF) != 8 ){
            $cNF = $ide->getElementsByTagName('cNF')->item(0)->nodeValue = rand( 10000001 , 99999999 );
        }
        $tempData =  $dt = explode("-", $dhEmi);
        $forma = "%02d%02d%02d%s%02d%03d%09d%01d%08d";//%01d";
        $tempChave = sprintf($forma ,
            $cUF ,
            $tempData[0] - 2000 ,
            $tempData[1] ,
            $CNPJ ,
            $mod ,
            $serie ,
            $nNF ,
            $tpEmis ,
            $cNF);

        $cDV    = $ide->getElementsByTagName('cDV')->item(0)->nodeValue  = $this->__calculaDV($tempChave);
        $chave  = $tempChave .= $cDV;
        $infNFe =  $this->DOM->getElementsByTagName("infNFe")->item(0);
        $infNFe->setAttribute("Id", "NFe" .  $chave);
        $this->chaveAcesso = $chave;
    }

}
//VERSAO 2.19.123