/*
Tecnisa - Tecnologia em Informtica

Nome: PRODNIVEL

Descrio:
   View que retorna o cdigo do produto junto aos seus nveis anteriores.
   Exemplo:  CDPRODUTO       CDPRODNIVEL
             1.1.01.001.00   1
             1.1.01.001.00   1.1
             1.1.01.001.00   1.1.01
             1.1.01.001.00   1.1.01.001
             1.1.01.001.00   1.1.01.001.00

Criao:
10/04/2000 - Newton N. Santos
06/08/20116 - Manuteno para considerar o CDARVPROD no lugar do CDPRODUTO

@H:\Sistemas\Dba\Sql\Oracle\0007_GERVIE_PRODNIVEL.SQL
*/

CREATE OR REPLACE VIEW PRODNIVEL AS
SELECT P1.CDPRODUTO  CDPRODNIVEL,
       P1.CDARVPROD  CDARVNIVEL,
       P2.CDPRODUTO,
       P2.CDARVPROD,
       P2.CDPRODESTO,
       P2.SGUNIDADE,
       P1.CDNVPRODUTO,
       P2.NMPRODUTO,
       P1.NMPRODUTO AS NMPRODNIVEL
FROM PRODUTO P1, (SELECT CDPRODUTO, CDARVPROD, CDPRODESTO, SGUNIDADE, NMPRODUTO
                  FROM PRODUTO
                  WHERE CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO)
                                       FROM PRODUTO)) P2
WHERE (P2.CDARVPROD LIKE P1.CDARVPROD||'%')
/
-- VERSAO --
BEGIN ATUVEROBJ('PRODNIVEL','6.05.xxx'); END;
/